{$G+}
unit Obraz3D;

interface
uses Dos, Crt;

const
  _Z_Back        = $80;  { z souadnice pozad }

  { viz TYP bodu }
  _Mazat         = $10;  { Bod je samostatne pamti a se zhasnutm pestane existovat }
  _Pouzit        = $20;  { Bod je zobrazen }
  _Pozadi        = $40;  { Bod je pozad }

  Maximum_Obrazu = 65535 div 6; { maximln poet bod spojitho obrazu }

  __Sada_3D_8X8  = $80;         { grafick mdy }
  __Sada_2D_8X8  = $40;

type
  Typ_Ind_Obrazu        = 0..Maximum_Obrazu-1;
  Typ_Pole_Bytu         = array[0..65534]of Byte; { pomocn typy }
  Ptr_to_Pole_Bytu      = ^Typ_Pole_Bytu;

  Bod_Fyz_Obrazu = record { bod klasick textov obrazovky, t.j. znak a jeho atribut }
                     case Boolean of
                       True  : ( Znak : Char; Atrib : Byte );
                       False : ( Word : Word ); end;

  Typ_Obrazu_2D         = array[Typ_Ind_Obrazu]of Bod_Fyz_Obrazu; { tak vypad v pamti obrazovka }
  Ptr_to_2D_Obraz       = ^Typ_Obrazu_2D;

  Typ_Obraz_2D = object
             Velikost     : Word;
             X_Obr, Y_Obr : Byte;
             _Typ_Obr     : Byte;
      { x x x x x x x x                                              }
      { ^ ^ ^ ^ ^ ^ ^ ^                                              }
      { | | | | | | | |                                              }
      { | | ---------------> zapnuty reim zobrazen                 }
      { | -----------------> sada 8x8                                }
      { -------------------> 1 .. zapnuta 3D sada                    }

              { tohle sou rozmery obrazovky }
             Fyz_Obraz    : Ptr_to_2D_Obraz;
              { adresa fyzicke obrazovky v pameti (bud $B800 nebo $B000) }
             Puv_Y_Obr, Puv_X_Obr, Puv_X, Puv_Y, Puvodni_mod, Bylo_8X8 : Byte;
              { parametry puvodni obrazovky (rozmer, kursor a mod) }

             procedure Zapis_Puvodni_mod;
              { do svch promnnch zape pvodn md obrazovky }
             procedure Zjisti_mod;
              { do svch promnnch zape nynj md obrazovky }
             procedure Zacni;
              { inicialisuje obrazovku }
             procedure Skoncuj;
              { ukon novou a nastav starou obrazovku }
             procedure Nastav_mod(Kterej : Byte);
              { nastav textov md obrazovky }
           Private
             procedure Sada_8X8_3D;
              { nastav hezkou sadu na obrazovce, znaky o velikosti 8x8 bod }
           end;


type
  Typ_Souradnic = Shortint; { typ souadnice dvou a trozmrnch bod }
  _Bod2D       = record
                   X, Y : Typ_Souradnic;
                 end;
  _Bod3D       = record
                   case Boolean of
                     True  : (X, Y, Z  : Typ_Souradnic);
                     False : (X2D, Y2D : Typ_Souradnic);
                 end;
  Ptr__Bod3D  = ^_Bod3D; { pomocn ukazatel }

  Typ_Bod_3D  = ^Typ_Ob_Bodu; { ukazatel na bod virtuln obrazovky }
  Typ_Ob_Bodu = record        { typ bodu virtuln obrazovky }
                  case Byte of
                    0    : ( _L, _H : Word); { pomocn promnn }
                    1    : (Typ   : Byte;
      { x x x x x x x x                                              }
      { ^ ^ ^ ^ ^ ^ ^ ^                                              }
      { | | | | | | | |                                              }
      { | | | | -----------> Lo adresy dalho v segmentu            }
      { | | | -------------> 1 .. Bod je v samostn pamti           }
      { | | ---------------> 1 .. Bod je pouit v 3D obrazu          }
      { | -----------------> 1 .. Bod je soust pozad             }
      { -------------------> zatm nepouit                          }
                             Z     : Shortint;
      { tohle je Z souradnice daneho bodu                            }
                             Dalsi : Word;
      { segment dalsiho bodu obrazu                                  }
                             Obsah : Bod_Fyz_Obrazu;);
      { obsah fyzick obrazovky                                      }
                    2    : ( Point : Typ_Bod_3D); { pomocn promnn }
                end;

  Typ_Obrazu_3D    = array[Typ_Ind_Obrazu]of Typ_Ob_Bodu; { typ pole, ve kterm jsou uloeny body pozad virtuln obrazovky }
  Ptr_to_3D_Obraz  = ^Typ_Obrazu_3D; { a typ ukazatele na toto pole }

  Ptr_to_3D_Obrazovka = ^Typ_Obrazovka_3D;
  Typ_Obrazovka_3D = object(Typ_Obraz_2D) { typ virtuln obrazovky }
             __Obraz : Ptr_to_3D_Obraz;
              { v tomto poli jsou ulozeny body pozadi }

             procedure Zobraz_Bod_Obsah_Xy (X, Y, Z : Typ_Souradnic; Co : Bod_Fyz_Obrazu);
             procedure Zhasni_Bod_Obsah_Xy (X, Y, Z : Typ_Souradnic; Co : Bod_Fyz_Obrazu);
              { zobraz a zhasnou znak a atribut (Co) na danou posici [X, Y, Z]. Pi zhasnut pestane bod existovat v pamti }
             procedure Zobraz_Bod_Pozadi_Xy(X, Y : Typ_Souradnic;Co : Bod_Fyz_Obrazu);
              { zobraz a zhasnou znak a atribut (Co) na danou posici [X, Y, -128] do pozad obrazovky }

             procedure Zobraz_Bod_Xy       (X, Y : Typ_Souradnic; Bod : Typ_Bod_3D);
             procedure Zhasni_Bod_Xy       (X, Y : Typ_Souradnic; Bod : Typ_Bod_3D);
              { zobraz a zhasnou bod ve virtuln obrazovce }
             procedure Obnov_Bod_Xy        (X, Y : Typ_Souradnic);
              { obnov bod virtuln obrazovky }
             procedure Presun_Bod_Xy       (X1, Y1, X2, Y2 : Typ_Souradnic; Bod : Typ_Bod_3D );
              { pesune bod ve virtuln obrazovce }

              { Na pozici [X, Y, Z] se me nachzet vce bod, jednoznan }
              { je bod uen pouze ukazatelem na tento bod }

             procedure Zacni;
              { Zabere v dynamick pamti msto pro pozad virtuln obrazovky, }
              { pizpsob do potebnho tvaru a pete do tto pamti to, }
              { co je prv na fyzick obrazovce. }

             procedure Cti_Pozadi;
              { Pete do pozad virtuln obrazovky prv aktivn fyzickou obrazovku }

             procedure Vytvor_Pozadi;
              { Pizpsob pam pro pozad virtuln obrazovky }
              { do potebnho tvaru (t.j. x*y cyklickch seznam) }

             procedure Obnov_Obraz;
              { Obnov obsah virtuln obrazovky na fyzickou }

	     procedure Zapis_Bmp(Kam : PathStr);

             procedure Nastav_mod(Kterej : Byte);
              { Zmn md fyzick i virtuln obrazovky (INT $10). }
              { Vzhledem k tomu, e se mn t rozmry obrazovky, }
              { pepot jej parametry. }

             procedure Skoncuj;
             procedure ClrScr;
              { Vymae pozad virtuln obrazovky }


             procedure Pis_Retez_Pozadi(X, Y : Typ_Souradnic; Pombarva : Byte; S : string);
              { etzec S zape barvou Color do pozad virtuln obrazovky. }

             procedure Pis_Retez(X, Y, Z : Typ_Souradnic;
                                Pombarva : Byte;
                                       S : string;
                                  Mezery : Boolean);
             procedure Smaz_Retez(X, Y, Z : Typ_Souradnic;
                                 Pombarva : Byte;
                                        S : string;
                                   Mezery : Boolean);
              { Obdobn jako Zobraz a Zhasni Bod Obsah. V pamti se vytvo 3D obrazy }
              { znak tohoto etzu a ty se zobraz do virtuln obrazovky. Parametr Mezery }
              { uruje, zda jsou mezery etzce pln nebo prhledn. }
           Private
             procedure Zrus_Pozadi;
              { Na fyzickou obrazovku pepe pozad z virtuln }
              { a uvoln samostatnou pam virtuln obrazovky }
              { (t.j. pozad a samostatn body) }
             procedure Zobraz_Bod_Pozadi(Adrobj : Integer; Co : Bod_Fyz_Obrazu);
             procedure Copy_Screen( Pom3D :  Ptr_to_3D_Obraz; Pomvel  : Word;
                                   Zbytek :  Bod_Fyz_Obrazu);

           end;
const
  Pamet_Bod_3D = SizeOf(Typ_Ob_Bodu);
  Mizera         : Bod_Fyz_Obrazu = ( Znak : ' '; Atrib : 7 );
  __Nula3D       : Typ_Ob_Bodu = (Typ : 0; Z : -128; _H : 0; Obsah : (Znak : ' '; Atrib : 7));
  __Nula_3D      : _Bod3D = (X:0;Y:0;Z:0);

var
  ___Bod    : _Bod3D; { pro predavani hodnot }


function Xyz_Bod(X, Y, Z : Typ_Souradnic):Ptr__Bod3D;

implementation
const __Y_Obr : Pointer = Ptr($40,$84);

type __Znak  = array[0..7]of Byte;
     __Znaky = array[Byte]of __Znak;
     __Typ_Sada = ^__Znaky;

const
  __Znak1: __Znak = ($7 ,$8 ,$10,$20,$40,$Ff,$80,$80);
  __Znak2: __Znak = ($Ff,0  ,0  ,0  ,0  ,$Ff,0  ,0  );
  __Znak3: __Znak = ($Ff,$3 ,$5 ,$9 ,$11,$E1,$21,$21);
  __Znak4: __Znak = ($80,$80,$80,$80,$80,$Ff,$0 ,$0 );
  __Znak5: __Znak = ($0 ,$0 ,$0 ,$0 ,$0 ,$Ff,$0 ,$0 );
  __Znak6: __Znak = ($21,$22,$24,$28,$30,$E0,$0 ,$0 );
  __Znak7: __Znak = ($80,$80,$80,$80,$80,$80,$80,$80);
  __Znak8: __Znak = ($21,$21,$21,$21,$21,$21,$21,$21);
  __Znak9: __Znak = ($C3,$44,$48,$50,$60,$Ff,$0 ,$0 );
  __Znak0: __Znak = ($0 ,$0 ,$0 ,$0 ,$0 ,$Ff,$42,$42);
  __Znaka: __Znak = ($42,$42,$42,$42,$42,$42,$42,$42);
  __Znakb: __Znak = ($00,$03,$04,$08,$10,$20,$7F,$42);
  __Znakc: __Znak = ($42,$C3,$44,$48,$50,$60,$Ff,$00);
  __Znakd: __Znak = ($00,$Fe,$06,$0A,$12,$22,$C2,$42);
  __Znake: __Znak = ($00,$Ff,$00,$00,$00,$00,$Ff,$00);
  __Znakf: __Znak = ($21,$21,$22,$24,$28,$30,$3F,$21);
  __Znakg: __Znak = ($42,$C2,$44,$48,$50,$60,$C0,$00);
  __Znakh: __Znak = ($42,$43,$44,$48,$50,$60,$7F,$00);
  __Znaki: __Znak = ($42,$C2,$42,$42,$42,$42,$C2,$42);
  __Znakj: __Znak = ($42,$43,$44,$48,$50,$60,$7F,$42);

function Dej_Sadu_3D : __Typ_Sada;
var Sada : __Typ_Sada;
       R : Registers;
begin
  New(Sada);

  R.Ax := $1130;
  R.Bh := $03;
  Intr($10,R);   {zjisteni sady 8x8}
  Sada^ := __Znaky(Ptr(R.Es,R.Bp)^);
  Sada^[213] := __Znak1; Sada^[205] := __Znak2;  { }
  Sada^[187] := __Znak3; Sada^[192] := __Znak4;  { }
  Sada^[196] := __Znak5; Sada^[189] := __Znak6;  { }
  Sada^[179] := __Znak7; Sada^[186] := __Znak8;  { }
  Sada^[207] := __Znak9; Sada^[194] := __Znak0;  { }
  Sada^[124] := __Znaka; Sada^[218] := __Znakb;  {| }
  Sada^[193] := __Znakc; Sada^[191] := __Znakd;  { }
  Sada^[ 45] := __Znake; Sada^[199] := __Znakf;  {- }
  Sada^[217] := __Znakg; Sada^[200] := __Znakh;  { }
  Sada^[182] := __Znaki; Sada^[195] := __Znakj;  { }
  Dej_Sadu_3D := Sada;
end;
var file_Ven  : text;

procedure Typ_Obrazovka_3D.Zapis_Bmp;
const Lh2 = 61;
type Typ_Hearder2 = array[0..Lh2]of Byte;
const
  Hearder2 : Typ_Hearder2 = ($42,$4D,$3E,$7D, 0,0,0,0, 0,0,$3E,0, 0,0,$28,0,
                             0,0,$80,2, 0,0,$90,1, 0,0,1,0, 1,0,0,0,
                             0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                             0,0,0,0, 0,0,0,0, 0,0,$Ff,$Ff, $Ff, 0);

var X, Y, I      : Integer;
    Ccc       : Char;
    Line      : Ptr_to_Pole_Bytu;
    Ukline    : Integer;
    Sada      : __Typ_Sada;


begin
  Sada   := Dej_Sadu_3D;
  Ukline := 1;
  Assign(file_Ven, Kam);
  Rewrite(file_Ven);
  for I := 0 to Lh2 do Write(file_Ven, Char(Hearder2[I]));

  for Y := Y_Obr-1 downto 0 do
    begin
      for I := 7 downto 0 do
        for X := 0 to X_Obr-1 do
          begin
            Ccc := Typ_Bod_3D(Ptr(__Obraz^[X+Y*X_Obr]._H, __Obraz^[X+Y*X_Obr]._L and $F))^.Obsah.Znak;
            Write(file_Ven, Char(not(Sada^[Byte(Ccc)][I])));
          end;
    end;
  Dispose(Sada);

  Close(file_Ven);
end;


function Xyz_Bod(X, Y, Z : Typ_Souradnic):Ptr__Bod3D;
begin
  Xyz_Bod := @___Bod;
  ___Bod.X := X;
  ___Bod.Y := Y;
  ___Bod.Z := Z;
end;

procedure Typ_Obraz_2D.Skoncuj;
label Nebylo;
begin
  Asm
    Mov Ah, 0
    Les Di, Self
    Mov Al, Es:Puvodni_mod[Di]
    Int 010H

    Les Di, Self
    Cmp Es:[Di].Bylo_8X8, $Ff
    Jnz Nebylo
    Mov Bl, 0
    Mov Ax, 01112H
    Int 010H
Nebylo :
  end;
  X_Obr    := Puv_X_Obr;
  Y_Obr    := Puv_Y_Obr;
  Velikost := X_Obr*Y_Obr;
  GotoXY(Puv_X, Puv_Y);
end;

procedure Typ_Obraz_2D.Zapis_Puvodni_mod;
label Nebylo;
var R : Registers;
begin
  Asm
    Mov Ah, 0Fh                           { zjisteni modu }
    Int 010H

    Les Di, Self

    Mov Es:[Di].Puv_X_Obr, Ah   { ah = x }
    Mov Es:[Di].X_Obr, Ah
    Mov Es:[Di].Puvodni_mod, Al

    Les Di, __Y_Obr
    Mov Al, Es:[Di]                       { al = y - 1 }
    Inc Al                                { al = y }

    Les Di, Self
    Mov Es:[Di].Puv_Y_Obr , Al
    Mov Es:[Di].Y_Obr     , Al
    Mul Ah                                { ax = x*y }

    Mov Es:[Di].Velikost, Ax              { velikost = x*y }

    Mov Word Ptr Es:[Di].Fyz_Obraz  , 00000H
  end;

  if Puvodni_mod = 7
    then Asm Mov Word Ptr Es:[Di].Fyz_Obraz+2, 0B000H end
    else Asm Mov Word Ptr Es:[Di].Fyz_Obraz+2, 0B800H end;

  Asm
    Les Di, Self
    Mov Es:[Di].Bylo_8X8, 0

    Mov Ah, 011H
    Mov Al, 030H
    Mov Bh, 0

    Push Bp
    Int 010H
    Pop Bp

    Cmp Cx, 8
    Jnz Nebylo

    Les Di, Self
    Mov Es:[Di].Bylo_8X8, 0Ffh

Nebylo :
  end;

  Puv_X        := WhereX;
  Puv_Y        := WhereY;
end;


procedure Typ_Obraz_2D.Zjisti_mod;
begin
  Asm
    Mov Ah, 0Fh;
    Int 010H

    Les Di, Self
    Mov Es:[Di].X_Obr, Ah          { ah = x }

    Les Di, __Y_Obr
    Mov Al, Es:[Di]                { al = y-1 }
    Inc Al                         { al = y }

    Les Di, Self
    Mov Es:[Di].Y_Obr, Al
    Mul Ah                         { ax = x*y }
    Mov Es:[Di].Velikost, Ax
    Mov Word Ptr Es:[Di].Fyz_Obraz, 00000H
  end;

  if Puvodni_mod = 7
    then Asm Mov Word Ptr Es:[Di].Fyz_Obraz+2, 0B000H end
    else Asm Mov Word Ptr Es:[Di].Fyz_Obraz+2, 0B800H end;
end;

procedure Typ_Obraz_2D.Zacni;
begin
  Zapis_Puvodni_mod;
  Zjisti_mod;
end;

procedure Typ_Obraz_2D.Nastav_mod(Kterej : Byte);
begin
  Asm
    Mov Ah, 00;
    Mov Al, Kterej
    and Al, 07H
    Int 010H
  end;
  if (Kterej and $C0) <> 0
    then if Puvodni_mod <> 7 then
           if (Kterej and $80) <> 0
             then Sada_8X8_3D
             else Asm
                    Mov Bl, 0
                    Mov Ax, 01112H
                    Int 010H
                  end;

  Zjisti_mod;
end;

procedure Typ_Obraz_2D.Sada_8X8_3D;
{ nastavi bitovou mapu }
{ ramecku pro 3d objekty }
var Sada : __Typ_Sada;

begin
  Sada := Dej_Sadu_3D;

  Asm            Mov Ax, 01110H
                 Mov Bx, 00800H
                 Mov Cx, 000Ffh
                 Mov Dx, 00000H
                 Mov Es, Word Ptr Sada+2
                 Push Bp
                 Mov Bp, Word Ptr Sada
                 Int 010H
                 Pop Bp
  end;

  Y_Obr    := Mem[$40:$84]+1;
  Velikost := X_Obr*Y_Obr;

  Dispose(Sada);
end;

procedure Typ_Obrazovka_3D.Copy_Screen( Pom3D :  Ptr_to_3D_Obraz;
                     Pomvel  : Word;
                      Zbytek : Bod_Fyz_Obrazu);
var Velcykl1, Velcykl2, I : Word;
begin
  if Pomvel > Velikost
    then begin Velcykl1 := Velikost-1; Velcykl2 := Pomvel-1 end
    else begin Velcykl2 := Velikost-1; Velcykl1 := Pomvel-1 end;

  for I := 0 to Velcykl1 do Zobraz_Bod_Pozadi(I, Pom3D^[I].Obsah);
  for I := Velcykl1+1 to Velcykl2 do Zobraz_Bod_Pozadi(I, Mizera);
end;

procedure Typ_Obrazovka_3D.Nastav_mod(Kterej : Byte);
var Pom3D : Ptr_to_3D_Obraz;
    Pomvel : Word;
begin
  Pomvel := Velikost;
  Pom3D  := __Obraz;
  Typ_Obraz_2D.Nastav_mod(Kterej);
  if Velikost <> Pomvel then
    begin
      GetMem(__Obraz, Velikost*Pamet_Bod_3D);
      Vytvor_Pozadi;
      Copy_Screen( Pom3D, Pomvel, Mizera);
      FreeMem(Pom3D, Pomvel*Pamet_Bod_3D)
    end;
  Obnov_Obraz;
end;

procedure Typ_Obrazovka_3D.Zobraz_Bod_Obsah_Xy(X, Y, Z : Typ_Souradnic;  Co : Bod_Fyz_Obrazu);
label Nezobrazit;
var Pom : Typ_Bod_3D;
begin
  Asm
                 Les Di, Self
                 Mov Cl, X
                 Cmp Cl, 0
                 Js Nezobrazit
                 Cmp Cl, Es:[Di].X_Obr
                 Jge Nezobrazit
                 Mov Bl, Y
                 Cmp Bl, 0
                 Js Nezobrazit
                 Cmp Bl, Es:[Di].Y_Obr
                 Jge Nezobrazit
  end;

  New(Pom);
  Pom^.Z     := Z;
  Pom^.Typ   := _Mazat;
  Pom^.Obsah := Co;
  Zobraz_Bod_Xy(X, Y, Pom);

  Nezobrazit:
end;

procedure Typ_Obrazovka_3D.Zhasni_Bod_Obsah_Xy(X, Y, Z : Typ_Souradnic; Co : Bod_Fyz_Obrazu);
label Dalsi, Konec, Nezobrazit;
var    Bod : Typ_Bod_3D;
    Adrobj : Integer;
begin
  Bod := nil;
  Asm
                 Les Di, Self
                 Mov Cl, X
                 Cmp Cl, 0
                 Js Nezobrazit
                 Cmp Cl, Es:[Di].X_Obr
                 Jge Nezobrazit
                 Mov Bl, Y
                 Cmp Bl, 0
                 Js Nezobrazit
                 Cmp Bl, Es:[Di].Y_Obr
                 Jge Nezobrazit

                 Mov Al, Es:[Di].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx
                 Mov Adrobj, Ax

                 Push Ds

                 Lds Si, Self                        { hejbaci objekt }
                 Lds Si, Ds:[Si].__Obraz             { obraz3D }

                 shl Ax, 1
                 Mov Dx, Ax
                 shl Dx, 1
                 Add Dx, Ax                              { dx := dx*sizeof(typ_ob_bodu) }
                 Add Si, Dx                      { odkud se m zrusit }

                 Mov Al, Z
                 Mov Cx, Co

{ ds:si adresa dalsiho pixelu, dx:bx adresa predchoziho pixelu }

   Dalsi:        Mov Bx, Si                { uloen predchozi adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]               { adresa dalho prvku }
                 and Si, 0Fh

                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi { je to pozad ? }
                 Jnz Konec { ne - to, co se ma ruit, v seznamu nejni }


                 Cmp Al, Ds:Typ_Ob_Bodu([Si]).Z       { sou stejn Z ? }
                 Jne Dalsi                { nejsou ! }
                 Cmp Cx, Ds:Typ_Ob_Bodu([Si]).Obsah   { sou stejny obsahy ? }
                 Jne Dalsi                { nejsou ! }
                                          { sou stejny }
                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Mazat{ Je Pixel Samostatny ? }
                 Jz Dalsi         { nejni, nemuzu mazat, ale hledat dal }

                 Mov Word Ptr Bod, Si
                 Mov Word Ptr Bod+2, Ds
                   { ds:si ruseny bod   }
                   { dx:bx bod pred nim }
                 Lds Si, Ds:[Si]         { pointer z ds:[si] se pesune na dx:[bx] }
                 Mov Ax, Ds
                 Mov Ds, Dx
                 Mov Cx, Ds:[Bx]
                 and Cl,0F0H
                 and Si,0Fh
                 or Cx, Si
                 Mov Ds:[Bx], Cx
                 Mov Ds:[Bx+2], Ax
                   { dx:bx bod pred rusenym }

                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konec

                 Lds Bx, Ds:[Bx]
                 and Bx, 0Fh
                 Mov Ax, Ds:Typ_Ob_Bodu([Bx]).Obsah { bod byl vidt, na obrazovku mus nsledujc za tmto }
                 Mov Dx, Adrobj
                 shl Dx, 1
                 Lds Si, Self
                 Lds Si, Ds:[Si].Fyz_Obraz
                 Add Si, Dx


                 Mov Ds:[Si], Ax

    Konec :      Pop Ds
  end;
  if Bod <> nil then Dispose(Bod);
  Nezobrazit:
end;

procedure Typ_Obrazovka_3D.Vytvor_Pozadi;
{ procedura vytvo pozadi v poli obraz, t.j do Bod ulo:      }
{  - obsah fyzick obrazovky na dan pozici                     }
{  - souadnici Z = $80 (-128) _Z_Back                          }
{  - do hornch bit pole Typ nastav hodnotu 0110              }
{  - do spodnch bit pole typ a do pole dalsi                  }
{    ulo ukazatel na sebe sama                                }

label Pozadi;
begin
  Asm
              Push Ds
              Lds Bx, Self
              Mov Cx, ds:[bx].velikost  { poet prvk pozad }
              Les Di, Ds:Fyz_Obraz[Bx]  { adresa fyzick obrazovky }
              Lds Bx, Ds:[Bx].__Obraz     { adresa 3D obrazu }

    Pozadi:   Mov Ax, Bx                { normalizace adresy }
              and Bx, 0Fh
              shr Ax, 4
              Mov Dx, Ds
              Add Ax, Dx
              Mov Ds, Ax

              Mov Ds:Typ_Ob_Bodu([Bx]).Dalsi, Ax         { segment prvku }
              Mov Ax, Bx
              or Ax, _Pozadi+_Pouzit              { typ - pouzite pozadi }
              Mov Ds:[Bx], Ax
              Mov Ds:Typ_Ob_Bodu([Bx]).Z, _Z_Back { souadnice .. pozad }

              {#### cist !}
              Mov Dx, Es:[Di]                     { obsah fyz. obrazovky }
              Mov Ds:Typ_Ob_Bodu([Bx]).Obsah, Dx

              Add Bx, 6                                     { nov prvky }
              Inc Di
              Inc Di

              Loop Pozadi

              Pop Ds
  end
end;

procedure Typ_Obrazovka_3D.Zobraz_Bod_Pozadi_Xy    (X, Y : Typ_Souradnic;Co : Bod_Fyz_Obrazu);
label Nejni_Videt;
begin
  Asm
                 Push Ds

                 Les Di, Self
                 Mov Cl, X
                 Cmp Cl, 0
                 Js Nejni_Videt
                 Cmp Cl, Es:[Di].X_Obr
                 Jge Nejni_Videt
                 Mov Bl, Y
                 Cmp Bl, 0
                 Js Nejni_Videt
                 Cmp Bl, Es:[Di].Y_Obr
                 Jge Nejni_Videt

                 Mov Al, Es:[Di].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx               { ax = adrobj }

                 Lds Si, Self             { hejbaci objekt }
                 Les Di, Ds:[Si].Fyz_Obraz{ Obrazovka }
                 Lds Si, Ds:[Si].__Obraz  { pozadi }

                 shl Ax, 1                { adrobj * 2 }
                 Mov Bx, Ax
                 Add Di, Bx               { pricist k adrese fyz. obrazovky }

                 shl Bx, 1                { adrobj * 4 }
                 Add Bx, Ax               { adrobj * 6 }
                 Add Si, Bx               { adrobj * 6 pricist k adr. pozadi }

                 Mov Ax, Co               { ulo co do 3D }
                 Mov Ds:Typ_Ob_Bodu([Si]).Obsah, Ax

                 Lds Si, Ds:[Si]
                 and Si, 0Fh
                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi { je co taky na obrazovce ? }
                 Jz Nejni_Videt           { t.j. za nim je pozadi }

                 Mov Es:[Di], Ax

   Nejni_Videt : Pop Ds
  end
end;

procedure Typ_Obrazovka_3D.Zobraz_Bod_Pozadi(Adrobj : Integer; Co : Bod_Fyz_Obrazu);
{ do pozad umst procedura na posici Adrobj Co. Pokud pozad }
{ bylo vidt, zobraz co                                       }
{ procedura je v podku                                       }

label Nejni_Videt;
begin
  Asm
                 Push Ds

                 Lds Si, Self             { hejbaci objekt }
                 Les Di, Ds:[Si].Fyz_Obraz{ Obrazovka }
                 Lds Si, Ds:[Si].__Obraz  { pozadi }

                 Mov Bx, Adrobj           { adresa v obrazovce }
                 Cmp Bx, 0Ffffh
                 Jle Nejni_Videt
                 Cmp Bx, Ds:[Si].Velikost
                 Jg  Nejni_Videt

                 shl Bx, 1                { adrobj * 2 }
                 Mov Ax, Bx
                 Add Di, Bx               { pricist k adrese fyz. obrazovky }

                 shl Bx, 1                { adrobj * 4 }
                 Add Bx, Ax               { adrobj * 6 }
                 Add Si, Bx               { adrobj * 6 pricist k adr. pozadi }

                 Mov Ax, Co               { ulo co do 3D }
                 Mov Ds:Typ_Ob_Bodu([Si]).Obsah, Ax

                 Lds Si, Ds:[Si]
                 and Si, 0Fh
                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi { je co taky na obrazovce ? }
                 Jz Nejni_Videt           { t.j. za nim je pozadi }

                 Mov Es:[Di], Ax

   Nejni_Videt : Pop Ds
  end
end;

procedure Typ_Obrazovka_3D.Cti_Pozadi;
{ procedura pete fyzickou obrazovku a ulo do pozad 3D obrazovky }
{ procedura je v podku                                       }
var I : Word;
begin
  for I := 0 to Velikost-1 do
    Zobraz_Bod_Pozadi(I, Fyz_Obraz^[I]);
end;

procedure Typ_Obrazovka_3D.Obnov_Obraz;

{ procedura je v podku                                       }

label Zvets, Dalsi, Konec;
begin
  Asm
                 Push Ds

                 Lds Si, Self
                 Mov Cx, [Si].Velikost
                 Dec Cx
                 Les Di, [Si].Fyz_Obraz
                 Lds Si, [Si].__Obraz

    Dalsi:       Mov Ax, Ds          { ulozeni ds }
                 Lds Bx, [Si]
                 and Bx, 0Fh         { ds:[si] prvni prvek }
                 Mov Dx, Typ_Ob_Bodu([Bx]).Obsah { je, presun 3D -> fyz_obraz }

                 Mov Es:[Di], Dx

    Zvets:       Mov Ds, Ax
                 Add Si, 6
                 Add Di, 2
                 Loop Dalsi

                 Pop Ds
     Konec:
   end
end;

procedure Typ_Obrazovka_3D.ClrScr;

{ procedura je v podku                                       }

label Zvets, Dalsi, Konec;
begin
  Asm
                 Push Ds

                 Lds Si, Self
                 Mov Cx, [Si].Velikost
                 Les Di, [Si].Fyz_Obraz
                 Mov Dx, Mizera
                 Lds Si, [Si].__Obraz

    Dalsi:       Mov Ax, Ds             { ulozeni ds }
                 Mov Ds:Typ_Ob_Bodu([Si]).Obsah, Dx { 0 do pozadi }
                 Lds Bx, [Si]
                 and Bx, 0Fh            { ds:[si] prvni prvek }

                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Zvets               { nepise se na fyz. obrazovku }

                 Mov Es:[Di], Dx        { 0 do obrazovky }

    Zvets:       Mov Ds, Ax
                 Add Si, 6
                 Add Di, 2
                 Loop Dalsi

                 Pop Ds
     Konec:
   end
end;

procedure Typ_Obrazovka_3D.Zrus_Pozadi;
{ procedura je v podku                                       }

var Rus_Bod, Fyz, O3D, Tmp : Typ_Bod_3D;
label Nerusit, Dalsi1, Dalsi2, Dalsi3, Zvetsit;
begin
  Asm
                 Push Ds

                 Lds Si, Self
                 Mov Cx, [Si].Velikost
{                 Dec Cx}
                 Les Di, [Si].Fyz_Obraz
                 Lds Si, [Si].__Obraz

    Dalsi1:      Mov Bx, Typ_Ob_Bodu([Si]).Obsah { je, presun 3D -> fyz_obraz }

                 Mov Es:[Di], Bx     {  !!! doplnit uvolneni samostat. bodu }
                 Test Typ_Ob_Bodu([Si]).Typ, _Pozadi
                 Jz Zvetsit

                 Mov Word Ptr O3D, Si
                 Mov Word Ptr O3D+2, Ds
                 Mov Word Ptr Fyz, Di
                 Mov Word Ptr Fyz+2, Es

    Dalsi2:      Lds Si, Ds:[Si]
                 and Si, 0Fh
    Dalsi3:      Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi
                 Jnz Nerusit         { u neni dn voln bod }
                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Mazat
                 Jz Dalsi2

                 Mov Word Ptr Rus_Bod, Si
                 Mov Word Ptr Rus_Bod+2, Ds

                 Lds Si, Ds:[Si]
                 and Si, 0Fh
                 Mov Word Ptr Tmp, Si
                 Mov Word Ptr Tmp+2, Ds

                 Pop Ds
                 Push Cx

    end;         Dispose(Rus_Bod);
    Asm          Pop Cx
                 Push Ds

                 Mov Si, Word Ptr Tmp
                 Mov Ds, Word Ptr Tmp+2
                 Jmp Dalsi3


    Nerusit:     Mov Di, Word Ptr Fyz
                 Mov Es, Word Ptr Fyz+2
                 Mov Si, Word Ptr O3D
                 Mov Ds, Word Ptr O3D+2

    Zvetsit:     Add Si, 6
                 Add Di, 2
                 Loop Dalsi1

                 Pop Ds
  end;
end;

procedure Typ_Obrazovka_3D.Skoncuj;
{ procedura je v podku                                       }
var Pomvel : Word;
begin
  Pomvel := Velikost;
  Typ_Obraz_2D.Skoncuj;
  Zrus_Pozadi;
  FreeMem(__Obraz, Pomvel*Pamet_Bod_3D)
end;

procedure Typ_Obrazovka_3D.Zacni;
{ procedura je v podku                                       }
begin
  Typ_Obraz_2D.Zacni;
  GetMem(__Obraz, Velikost*Pamet_Bod_3D);
  Vytvor_Pozadi;
  Cti_Pozadi;
end;

procedure Typ_Obrazovka_3D.Zobraz_Bod_Xy(X, Y : Typ_Souradnic; Bod : Typ_Bod_3D);
label Je_Mensi, Konec;
var Adrobj : Integer;
begin
  Asm
                 Push Ds

                 Les Di, Self
                 Mov Cl, X
                 Cmp Cl, 0
                 Js Konec
                 Cmp Cl, Es:[Di].X_Obr
                 Jge Konec
                 Mov Bl, Y
                 Cmp Bl, 0
                 Js Konec
                 Cmp Bl, Es:[Di].Y_Obr
                 Jge Konec

                 Mov Al, Es:[Di].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx
                 Mov Adrobj, Ax

                  { vymaz bod adrobj }
                 Lds Si, Self             { hejbaci objekt }
                 Lds Si, Ds:[Si].__Obraz  { obraz3D }
                 shl Ax, 1
                 Mov Dx, Ax
                 shl Dx, 1
                 Add Dx, Ax               { dx := dx*6 }
                 Add Si, Dx               { kam se ma pridat }

                 Mov Ax, Si               { normalizace adresy }
                 and Si, 0Fh
                 shr Ax, 4
                 Mov Dx, Ds
                 Add Ax, Dx
                 Mov Ds, Ax

                 Les Di, Bod
                 Test Es:Typ_Ob_Bodu([Di]).Typ, _Pouzit
                 Jne Konec                { pixel je pouzit }

                 or Es:Typ_Ob_Bodu([Di]).Typ, _Pouzit { pixel bude pouzit }

                                          { es:di pidvan bod }
                 Mov Ax, Di               { normalisace adresy a ulozeni }
                 and Di, 0Fh
                 shr Ax, 4
                 Mov Dx, Es
                 Add Ax, Dx
                 Mov Es, Ax

                 Mov Ax, Es:[Di]          { typ a loadr noveho bodu do AL, z noveho bodu do AH }
                 and Al, 0F0H             { loadr = 0 }

   Je_Mensi:     Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Cmp Ah, Ds:Typ_Ob_Bodu([Si]).Z
                 Jl Je_Mensi

                 or  Si, Ax               { pridani adresy dalsiho }
                 Mov Es:[Di], Si          { prehozeni pointeru, novy prvek -> dalsi }
                 Mov Si, Ds
                 Mov Es:[Di+2], Si

                 Mov Ds, Dx               { predchozi -> novy }
                 Mov Ax, Ds:[Bx]
                 and Al, 0F0H
                 or Ax, Di
                 Mov Ds:[Bx], Ax
                 Mov Si, Es
                 Mov Ds:[Bx+2], Si

                 Mov Ds, Dx
                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konec

                 { nov bod m bt vidt }
                 Mov Ax, Es:Typ_Ob_Bodu([Di]).Obsah
                 Mov Dx, Adrobj
                 shl Dx, 1
                 Lds Si, Self
                 Lds Si, Ds:[Si].Fyz_Obraz
                 Add Si, Dx

                 Mov Ds:[Si], Ax

    Konec :      Pop Ds
  end
end;

procedure Typ_Obrazovka_3D.Zhasni_Bod_Xy    (X,Y : Typ_Souradnic; Bod : Typ_Bod_3D);
label Dalsi, Konec;
var Adrobj : Integer;
begin
  Asm
                 Push Ds

                 Les Di, Self
                 Mov Cl, X
                 Cmp Cl, 0
                 Js Konec
                 Cmp Cl, Es:[Di].X_Obr
                 Jge Konec
                 Mov Bl, Y
                 Cmp Bl, 0
                 Js Konec
                 Cmp Bl, Es:[Di].Y_Obr
                 Jge Konec

                 Mov Al, Es:[Di].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx
                 Mov Adrobj, Ax
                   { vymaz_bod adrobj = ax }
                 Lds Si, Self             { Typ_Obrazovka_3D }
                 Lds Si, Ds:[Si].__Obraz  { obraz3D }
                 shl Ax, 1
                 Mov Dx, Ax
                 shl Dx, 1
                 Add Dx, Ax               { dx := dx*6 }
                 Add Si, Dx               { odkud se m zruit }

                 Les Di, Bod              { es:di ruen bod }
                 Mov Ax, Di               { normalisace adresy a ulozeni }
                 and Di, 0Fh
                 shr Ax, 4
                 Mov Dx, Es
                 Add Ax, Dx
                 Mov Es, Ax

   Dalsi:        Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi { je to pozad ? }
                 Jnz Konec                { ne - to, co se ma ruit, v seznamu nejni }

                 Mov Cx, Ds
                 Cmp Ax, Cx               { sou stejn segmenty ? }
                 Jne Dalsi                { nejsou ! }
                 Cmp Si, Di               { sou stejny offsety ? }
                 Jne Dalsi                { nejsou ! }

                 and Es:Typ_Ob_Bodu([Di]).Typ, $Ff xor _Pouzit
                   { ds:si es:di oba ruseny bod }
                   { dx:bx bod pred nim         }
                 Lds Si, Ds:[Si]         { pointer z ds:[si] se pesune na dx:[bx] }
                 Mov Ax, Ds
                 Mov Ds, Dx
                 Mov Cx, Ds:[Bx]
                 and Cl,0F0H
                 and Si,0Fh
                 or Cx, Si
                 Mov Ds:[Bx], Cx
                 Mov Ds:[Bx+2], Ax

                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konec

                 Lds Bx, Ds:[Bx]
                 and Bx, 0Fh
                 Mov Ax, Ds:Typ_Ob_Bodu([Bx]).Obsah { bod byl vidt, na obrazovku mus nsledujc za tmto }
                 Mov Dx, Adrobj
                 shl Dx, 1
                 Lds Si, Self
                 Lds Si, Ds:[Si].Fyz_Obraz
                 Add Si, Dx

                 Mov Ds:[Si], Ax

    Konec :      Pop Ds
  end;
end;

procedure Typ_Obrazovka_3D.Obnov_Bod_Xy    (X,Y : Typ_Souradnic);
label Dalsi, Konec;
var Adrobj : Integer;
begin
  Asm
                 Push Ds

                 Les Di, Self
                 Mov Cl, X
                 Cmp Cl, 0
                 Js Konec
                 Cmp Cl, Es:[Di].X_Obr
                 Jge Konec
                 Mov Bl, Y
                 Cmp Bl, 0
                 Js Konec
                 Cmp Bl, Es:[Di].Y_Obr
                 Jge Konec

                 Mov Al, Es:[Di].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx
                 Mov Adrobj, Ax

                  { obnov bod adrobj }
                 Lds Si, Self             { Typ_Obrazovka_3D }
                 Lds Si, Ds:[Si].__Obraz  { obraz3D }

                 shl Ax, 1
                 Mov Dx, Ax
                 shl Dx, 1
                 Add Dx, Ax               { dx := dx*6 }
                 Add Si, Dx               { odkud se m zruit }

   Dalsi:        Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Mov Ax, Ds:Typ_Ob_Bodu([Si]).Obsah

                 Mov Dx, Adrobj
                 shl Dx, 1
                 Lds Si, Self
                 Lds Si, Ds:[Si].Fyz_Obraz
                 Add Si, Dx

                 Mov Ds:[Si], Ax

    Konec :      Pop Ds
  end;
end;

procedure Typ_Obrazovka_3D.Presun_Bod_Xy(X1, Y1, X2, Y2 : Typ_Souradnic; Bod : Typ_Bod_3D );
label Dalsi, Konecr, Konecs, Konecp, Je_Mensi;
var A1, A2 : Integer;

begin
  Asm
                 Push Ds

                 Les Di, Bod              { es:di ruen bod }
                 Mov Ax, Di               { normalisace es:[di] }
                 and Di, 0Fh
                 shr Ax, 4
                 Mov Dx, Es
                 Add Ax, Dx
                 Mov Es, Ax

{                 Test Es:Typ_Ob_Bodu([Di]).Typ, _Pouzit pokud byl mimo obraz, nebyl pouzit a bude pouzit
                 Jz Konecp                { nebyl pouzit, neda se nic delat }

                 Lds Si, Self
                 Mov Cl, X1
                 Cmp Cl, 0
                 Js Konecr
                 Cmp Cl, Ds:[Si].X_Obr
                 Jge Konecr
                 Mov Bl, Y1
                 Cmp Bl, 0
                 Js Konecr
                 Cmp Bl, Ds:[Si].Y_Obr
                 Jge Konecr

                 Mov Al, Ds:[Si].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx
                 Mov A1, Ax

    { viz vymaz_bod }

                 Lds Si, Self             { Typ_Obrazovka_3D }
                 Lds Si, Ds:[Si].__Obraz   { obraz3D }

                 Mov Dx, Ax               { adresa v obrazovce }
                 shl Dx, 1
                 Mov Ax, Dx
                 shl Dx, 1
                 Add Dx, Ax               { dx := dx*6 }
                 Add Si, Dx               { odkud se m zruit }

                 Mov Ax, Es

   Dalsi:        Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi { je to pozad ? }
                 Jnz Konecr               { ne - to, co se ma ruit, v seznamu nejni }

                 Mov Cx, Ds
                 Cmp Ax, Cx               { sou stejn segmenty ? }
                 Jne Dalsi                { nejsou ! }
                 Cmp Si, Di               { sou stejny offsety ? }
                 Jne Dalsi                { nejsou ! }

                   { ds:si es:di oba ruseny bod }
                   { dx:bx bod pred nim         }
                 Lds Si, Ds:[Si]         { pointer z ds:[si] se pesune na dx:[bx] }
                 Mov Ax, Ds
                 Mov Ds, Dx
                 Mov Cx, Ds:[Bx]
                 and Cl,0F0H
                 and Si,0Fh
                 or Cx, Si
                 Mov Ds:[Bx], Cx
                 Mov Ds:[Bx+2], Ax

                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konecr               { bod neni videt }

                 Lds Bx, Ds:[Bx]
                 and Bx, 0Fh
                 Mov Ax, Ds:Typ_Ob_Bodu([Bx]).Obsah { bod byl vidt, na obrazovku }
                 Mov Dx, A1              {  mus nsledujc za tmto }
                 shl Dx, 1
                 Lds Si, Self
                 Lds Si, Ds:[Si].Fyz_Obraz
                 Add Si, Dx

                 Mov Ds:[Si], Ax

    Konecr :
      { viz set_bod }
                 Lds Si, Self
                 Mov Cl, X2
                 Cmp Cl, 0
                 Js Konecs
                 Cmp Cl, Ds:[Si].X_Obr
                 Jge Konecs
                 Mov Bl, Y2
                 Cmp Bl, 0
                 Js Konecs
                 Cmp Bl, Ds:[Si].Y_Obr
                 Jge Konecs

                 Mov Al, Ds:[Si].X_Obr
                 xor Ah, Ah
                 xor Bh, Bh
                 Mul Bx
                 xor Ch, Ch
                 Add Ax, Cx
                 Mov A2, Ax

                 Lds Si, Self             { hejbaci objekt }
                 Lds Si, Ds:[Si].__Obraz    { obraz3D }

                 Mov Dx, Ax           { adresa v obrazovce }
                 shl Dx, 1
                 Mov Ax, Dx
                 shl Dx, 1
                 Add Dx, Ax               { dx := dx*6 }
                 Add Si, Dx               { kam se ma pridat }

                 Mov Ax, Si               { normalizace adresy ds:[si]}
                 and Si, 0Fh
                 shr Ax, 4
                 Mov Dx, Ds
                 Add Ax, Dx
                 Mov Ds, Ax

                                          { es:[di] bod z vymaz_bod }
                 Mov Ax, Es:[Di]          { typ a loadr noveho bodu do AL, z noveho bodu do AH }
                 and Al, 0F0H             { loadr = 0 }

   Je_Mensi:     Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Cmp Ah, Ds:Typ_Ob_Bodu([Si]).Z
                 Jl Je_Mensi

                 or  Si, Ax               { pridani adresy dalsiho }
                 Mov Es:[Di], Si          { prehozeni pointeru, novy prvek -> dalsi }
                 Mov Si, Ds
                 Mov Es:[Di+2], Si

                 Mov Ds, Dx               { predchozi -> novy }
                 Mov Ax, Ds:[Bx]
                 and Al, 0F0H
                 or  Ax, Di
                 Mov Ds:[Bx], Ax
                 Mov Si, Es
                 Mov Ds:[Bx+2], Si

                 Mov Ds, Dx
                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konecs

                 { nov bod m bt vidt }
                 Mov Ax, Es:Typ_Ob_Bodu([Di]).Obsah
                 Mov Dx, A2
                 shl Dx, 1
                 Lds Si, Self
                 Lds Si, Ds:[Si].Fyz_Obraz
                 Add Si, Dx
                 Mov Ds:[Si], Ax
    Konecs :
    Konecp :     Pop Ds
  end;
end;
procedure Typ_Obrazovka_3D.Pis_Retez_Pozadi(X, Y : Typ_Souradnic; Pombarva : Byte; S : string);
var Adrobj, Pom, J, I : Integer;  {v obrazovce a na jeho z-souradnici}
    U                 : _Bod3D;             {v poli obraz}
    Fn                : Bod_Fyz_Obrazu;
    Zobraz            : Boolean;
begin
  Adrobj := X_Obr*Y+X;
  if (Adrobj < Velikost) then
    begin
      Pom := 1;
      Fn.Atrib := Pombarva;
      for I := Adrobj to Adrobj + Byte(S[0])-1 do
        begin
          Fn.Znak := S[I-Adrobj+1];
           Zobraz_Bod_Pozadi(I, Fn);
        end;
    end;
end;

procedure Typ_Obrazovka_3D.Pis_Retez(X, Y, Z : Typ_Souradnic;
                       Pombarva : Byte;
                           S : string;
                      Mezery : Boolean);
var I  : Integer;  {v obrazovce a na jeho z-souradnici}
    Fn : Bod_Fyz_Obrazu;
begin
  Fn.Atrib := Pombarva;
  for I := 1 to Byte(S[0]) do
    begin
      if not Mezery then
         while (S[I] = ' ') and (I < Byte(S[0])-1)
           do Inc(I);
      Fn.Znak := S[I];
       Zobraz_Bod_Obsah_Xy(X+I-1, Y, Z, Fn);
    end;
end;

procedure Typ_Obrazovka_3D.Smaz_Retez(X, Y, Z : Typ_Souradnic;
                      Pombarva : Byte;
                      S : string;
                      Mezery : Boolean);
var Adrobj, I : Integer;  {v obrazovce a na jeho z-souradnici}
    Fn        : Bod_Fyz_Obrazu;
begin
  Adrobj :=  X_Obr*Y+X;
  Fn.Atrib := Pombarva;
  for I := 1 to Byte(S[0]) do
    begin
      if not Mezery then
         while (S[I] = ' ') and (I < Byte(S[0])-1)
           do Inc(I);
      Fn.Znak := S[I];
       Zhasni_Bod_Obsah_Xy(X+I-1, Y, Z, Fn);
    end;
end;


end.

(*procedure Typ_Obrazovka_3D.Hard_Copy(var Kam : text; Typ : Byte);
{pro epson !!!}
var X, Y      : Integer;
    Ccc       : Char;
    Line      : Ptr_to_Pole_Bytu;
    Ukline    : Integer;
    Sada      : __Typ_Sada;

  procedure Znakven(Kterej : Byte; Obs : __Znak);
  var Fn, Bz, Xs, Un : Byte;
  begin
    for Fn := 0 to 7 do
      begin
        Xs := 0;
        Un := $80 shr Fn;
        for Bz := 0 to 7 do
          if (Un and Obs[Bz]) <> 0 then
            Xs := Xs or ($80 shr Bz);
        Line^[Ukline] := Xs;
        Inc(Ukline);
      end;
  end;

  procedure Lineven;
  var I : Integer;
  begin
    Dec(Ukline);
    Write(Kam, #27'*'#6,Char(Lo(Ukline)),Char(Hi(Ukline)));
    for I := 1 to Ukline do Write(Kam, Char(Line^[I]));
    WriteLn(Kam);
    Ukline := 1;
  end;

begin
  Sada   := Dej_Sadu_3D;
  Ukline := 1;

  if (Typ and $1) <> 0 then
    begin
      Write(Kam,#27,#51,#24);
      GetMem(Line, Y_Obr*8)
    end;

  for Y := 0 to Y_Obr - 1 do
    begin
      X := X_Obr-1;
      while (X > 0) and (Typ_Bod_3D(Ptr(__Obraz^[X+Y*X_Obr]._H, __Obraz^[X+Y*X_Obr]._L and $F))^.Obsah.Znak = ' ') do Dec(X);
      for X := 0 to X do
        begin
          Ccc := Typ_Bod_3D(Ptr(__Obraz^[X+Y*X_Obr]._H, __Obraz^[X+Y*X_Obr]._L and $F))^.Obsah.Znak;
          if (Typ and $1) <> 0
            then Znakven(Byte(Ccc), Sada^[Byte(Ccc)])
            else Write(Kam, Ccc);
        end;
      Lineven;
    end;
  Dispose(Sada);
end;
*)
  __Graph_Copy   = $01;
  __text_Copy    = $02;
