{3 toto je pro tiskrnu, men dkovn (30)}
unit Unfront;

interface uses Unhejb;
const
  __Pracuje_Se    = $01;  { pracueje se s prvky seznamu ( zaazuje nebo vyazuje ) }
  __Na_Int        = $02;  { fronta sedi na interruptu }
  __Maka          = $04;  { probiha makej - fronta se zpracovava }
  __Volat_Puvodni = $08;  { bude se volat puvodni rutina }

type
  Pom_Uk_Fronta = ^Typ_Co_Se_Hejbe;
  Typ_Co_Se_Hejbe = record
                      Pohyb     : Ptr_Typ_Hejbaci;
                      Dalsi     : Pom_Uk_Fronta;
                      Predchozi : Pom_Uk_Fronta;
                    end;


 Typ_Hejb_Fronta = object
                      constructor Init;
                      destructor Zrus;

                      function Hejbe_Se : Boolean;
                       { zjist, zda se njak objekt hbe }
                      procedure Makej;
                       { posune vechny objekty, kter se  maj hbat po cest o 1 krok }

                      procedure set_Pomalost( _Pomalost : Word);
                      procedure Zarad_Prvek(var Kterej : Typ_Hejbaci_Zaklad);
                      procedure Stop_Vsechny;
                      procedure __Vyhod_Prvek(Kterej : Pom_Uk_Fronta);
                       { zastav vechny objekty na jejich drze }
                      procedure Rozbeh_Vsechny;
                       { rozebhne vechny objekty na dan drze }
                      procedure Dodelej_Pohyb;
                       { dokon pohyb vech prvk v seznamu }
                       { if Makat -> opakuje proceduru makej }
                      procedure Dodelej_Pohyb_Na_Pocet(Kolik : Word);
                      function Pocet : Word;
                      procedure Vypis;
                    Private
                      Seznam   : Pom_Uk_Fronta;
                      __Stav   : Byte;
                      Pomalost : Word;
                    end;

  Typ_Hejb_Fronta_Intr = object(Typ_Hejb_Fronta)
                           constructor Init(Ktere_Intr : Byte; Volat_Puvodni : Boolean);
                           destructor Zrus;

                           procedure On;
                           procedure Off;
                           function  Je_Intr : Boolean;
                           procedure Makej;

                         Private
                           Num_Intr   : Byte;
                           Stare_Intr : Pointer;
                           Nove_Intr  : Pointer;
                           procedure _Makej;

                         end;

const
  _Stand_Pomalost : Word = 50;
procedure set_Pomalost( _Pomalost : Word);

implementation
uses Crt, Dos;
type
  Typ_Pole_Bytu  = array[0..65534]of Byte;

procedure set_Pomalost( _Pomalost : Word);
begin
  _Stand_Pomalost := _Pomalost;
end;

procedure Typ_Hejb_Fronta.Zarad_Prvek(var Kterej : Typ_Hejbaci_Zaklad);
var X : Pom_Uk_Fronta;
begin
  New(X);    {zarazeni objektu do seznamu aktivnich}
  X^.Pohyb  := @Kterej;
  if Seznam <> nil then
    begin
      X^.Dalsi  := Seznam;
      X^.Predchozi := Seznam^.Predchozi;
      Seznam^.Predchozi^.Dalsi := X;
      Seznam^.Predchozi := X;
    end
  else
    begin
      X^.Dalsi := X;
      X^.Predchozi := X;
      Seznam := X;
    end;
end;

procedure Typ_Hejb_Fronta.__Vyhod_Prvek(Kterej : Pom_Uk_Fronta);
begin
  if Kterej = Seznam then           {ru se prvn prvek}
    if Kterej = Kterej^.Dalsi
      then Seznam := nil            {v seznamu byl jen jeden prvek}
      else Seznam := Seznam^.Dalsi; {v seznamu bylo vic prvku}
  __Stav := __Stav or __Pracuje_Se;
  Kterej^.Predchozi^.Dalsi := Kterej^.Dalsi;
  Kterej^.Dalsi^.Predchozi := Kterej^.Predchozi;
  __Stav := __Stav and not __Pracuje_Se;
  Dispose(Kterej);
end;

procedure Typ_Hejb_Fronta.Makej;
{ Projede seznam vsech objektu, ktere se maji hybat (hejbobj)}
{ a se vsemi objekty provede 1 krok}
var Obj, Objpuv, Objdalsi, Posledni : Pom_Uk_Fronta;
    Pom_Co    : Ptr_Typ_Hejbaci;
begin
  __Stav := __Stav or __Maka;
{  GotoXY(40,1); Write( 'avail: ', MemAvail, '   ');}
  if (Seznam <> nil) and ((__Stav and __Pracuje_Se) = 0) then
    begin
      Posledni := Seznam^.Predchozi;
      Objpuv   := Seznam^.Predchozi;
      Objdalsi := Seznam;
      repeat
        Obj := Objdalsi;
        Pom_Co := Obj^.Pohyb;
        Pom_Co^.Stav := Pom_Co^.Stav or __Zpracovava_Se;

        Objdalsi := Obj^.Dalsi;
        if Pom_Co^.Krok = 255
          then __Vyhod_Prvek(Obj);
        Pom_Co^.Stav := Pom_Co^.Stav and (not __Zpracovava_Se);
      until Obj = Posledni;
    end;
  __Stav := __Stav and not __Maka;
end;

procedure Typ_Hejb_Fronta.set_Pomalost( _Pomalost : Word);
begin
  Pomalost := _Pomalost;
end;

procedure Typ_Hejb_Fronta.Dodelej_Pohyb;
begin
  while Hejbe_Se do
    begin
      Makej;
      Delay(Pomalost);
    end;
end;

procedure Typ_Hejb_Fronta.Dodelej_Pohyb_Na_Pocet(Kolik : Word);
begin
  while Pocet <> Kolik do
    begin
      Makej;
      Delay(Pomalost);
    end;
end;

function Typ_Hejb_Fronta.Hejbe_Se : Boolean;
begin
  Hejbe_Se := Seznam <> nil
end;
{ ************************************************************************* }
{ ************************************************************************* }

const Pocinstr = 43;
constructor Typ_Hejb_Fronta_Intr.Init(Ktere_Intr : Byte; Volat_Puvodni : Boolean);
type Typstroj = array[0..Pocinstr-1]of Byte;
const Strojak : Typstroj = ($50, $53, $51, $52, $56, $57, $1E, $06, $55, {push}
			    $89, $E5,           {mov bp, sp}
			    $B8, $99, $99,      {mov ax, dseg 12}
                            $8E, $D8,	        {mov ds, ax}
                            $Bf, $99, $99,      {mov di, segself 17}
                            $57,                {push di}
                            $Bf, $99, $99,      {mov di, ofsself 21}
                            $57,                {push di}
                            $9A, $99, $99, $99, $99,{call far makej 25}
                            $C9,                {leave}
                            $07, $1F, $5F, $5E, $5A, $59, $5B, $58,{pop}
                            $Ea, 99, 99, 99, 99 {jmp far stare_intr 39}
                            { $cf                {iret});
var I : Integer;
    Makej_Ptr : Pointer;

begin
  Typ_Hejb_Fronta.Init;
  Num_Intr := Ktere_Intr;

  Makej_Ptr := @Typ_Hejb_Fronta_Intr._Makej;

  GetMem(Nove_Intr, Pocinstr);
  for I := 0 to Pocinstr-1 do
    Typ_Pole_Bytu(Nove_Intr^)[I] := Strojak[I];

      Asm
        Les Di, Self
        Les Di, Es:[Di].Nove_Intr
        Mov Ax, Seg @Data
        Mov Es:[Di+12], Ax
        Mov Ax, Word Ptr Self+2
        Mov Es:[Di+17], Ax
        Mov Ax, Word Ptr Self
        Mov Es:[Di+21], Ax

        Mov Ax, Word Ptr Makej_Ptr
        Mov Es:[Di+25], Ax
        Mov Ax, Word Ptr Makej_Ptr+2
        Mov Es:[Di+27], Ax
      end;
  if Volat_Puvodni
    then __Stav := __Stav or (__Volat_Puvodni)
    else __Stav := __Stav and (not __Volat_Puvodni)
end;

procedure Typ_Hejb_Fronta_Intr.On;
var Stare : Pointer;
begin
{  zapni_timer;}
  if (__Stav and __Na_Int) = 0 then
    begin
      GetIntVec(Num_Intr, Stare_Intr);
      Stare := Stare_Intr;
      if (__Stav and __Volat_Puvodni) <> 0 then
        Asm { stara rutina se bude volat, zapsat jeji adresu za jmp far }
          Les Di, Self
          Les Di, Es:[Di].Nove_Intr

          Mov Ax, Word Ptr Stare;
          Mov Es:[Di+39], Ax
          Mov Ax, Word Ptr Stare+2
          Mov Es:[Di+41], Ax
        end
      else Asm  { nebude se volat stara rutina, zapise se rti msto jmp far }
          Les Di, Self
          Les Di, Es:[Di].Nove_Intr

          Mov Byte Ptr Es:[Di+38], $Cf    {rti}
      end;


      __Stav := __Stav or __Na_Int;
      SetIntVec(Num_Intr, Nove_Intr);
    end;
end;

destructor Typ_Hejb_Fronta_Intr.Zrus;
begin
  FreeMem(Nove_Intr, Pocinstr);
  Off;
end;

procedure Typ_Hejb_Fronta_Intr.Makej;
begin
  if  (__Stav and __Na_Int) <> 0
    then Asm Int Num_Intr end
    else Typ_Hejb_Fronta.Makej;
end;

procedure Typ_Hejb_Fronta_Intr._Makej;
begin
  if ((__Stav and __Maka) = 0) and
     ((__Stav and __Pracuje_Se) = 0) then
    begin
      __Stav := __Stav or __Maka;
      Typ_Hejb_Fronta.Makej;
      __Stav := __Stav and (not __Maka)
    end
{  else begin GotoXY(1,1); WriteLn('Znova'); end;}
end;



procedure Typ_Hejb_Fronta_Intr.Off;
begin
  if (__Stav and __Na_Int) <> 0 then
    begin
      SetIntVec(Num_Intr, Stare_Intr);
      __Stav := __Stav and (not __Na_Int);
    end;
end;

function Typ_Hejb_Fronta_Intr.Je_Intr : Boolean;
begin
  Je_Intr := (__Stav and __Na_Int) <> 0
end;

constructor Typ_Hejb_Fronta.Init;
begin
  Pomalost := _Stand_Pomalost;
  __Stav := 0;
  Seznam := nil;
end;

destructor Typ_Hejb_Fronta.Zrus;
begin
end;

procedure Typ_Hejb_Fronta.Stop_Vsechny;
var Obj : Pom_Uk_Fronta;
begin
  Obj := Seznam;
  if Obj <> nil then
    repeat
      Obj^.Pohyb^.Stav := (not __Pohyb ) and Obj^.Pohyb^.Stav;
      Obj := Obj^.Dalsi
    until Obj = Seznam;
end;

procedure Typ_Hejb_Fronta.Rozbeh_Vsechny;
var Obj : Pom_Uk_Fronta;
begin
  Obj := Seznam;
  if Obj <> nil then
    repeat
      Obj^.Pohyb^.Stav := Obj^.Pohyb^.Stav or __Pohyb;
      Obj := Obj^.Dalsi
    until Obj = Seznam;
end;

function Typ_Hejb_Fronta.Pocet : Word;
var Obj : Pom_Uk_Fronta;
    Pompoc : Word;
begin
  Obj := Seznam;
  Pompoc := 0;
  if Obj <> nil then
    repeat
      Inc(Pompoc);
      Obj := Obj^.Dalsi
    until Obj = Seznam;
  Pocet := Pompoc;
end;

procedure Typ_Hejb_Fronta.Vypis;
var Obj : Pom_Uk_Fronta;
begin
  Obj := Seznam;
  GotoXY(1,1);
  if Obj <> nil then
    repeat
      WriteLn(Seg(Obj^):4,':',Ofs(Obj^):4);
      Obj := Obj^.Dalsi
    until Obj = Seznam;
end;


end.
