{ Jednotka, kter pedvd monosti zobrazen rznch objekt. }
{ Co obsahuj tyto objekty je ureno v procedue Vytvor        }
{ U objektu je nutno definovat procedury _zobraz a _zhasni.    }
{ Tyto uruj tvar objektu na obrazovce                        }
{ Procedura _presun_rel je nepovinn, je pouita proto,        }
{ aby se objekt rychleji hbal a neblikal                      }
{ Pokud je pouit constructor Init, je teba vdy nejdve     }
{ inicializovat typ_hejbaci (viz ne)                         }

{ Objekt Typ_hvezda dle pedvd pouit virtulnch metod    }
{ VM0 .. VM16                                                  }
{ Metoda VM0 mn velikost a VM1 barvu tohoto objektu          }

unit Unkriz;

interface

uses Obraz3D, Unhejb;
type
  Vzhled_Kriz = array[1..9]of Char;

const
  _Patky        : Vzhled_Kriz = ('','','','','','','','','');
  _Single       : Vzhled_Kriz = ('','','','','','','','','');
  _Strom        : Vzhled_Kriz = ('|','-','|','-','|','|','-','|','-');

type Typ_Kriz = object(Typ_Hejbaci)
                    _Velikost : Byte;
                    procedure Vytvor(Velikost : Byte; _Barva : Byte;  Typ : Vzhled_Kriz);
                    procedure _Zobraz; virtual;
                     { vytvo kopii objektu v obrazovce }
                    procedure _Zhasni; virtual;
                     { zhasne objekt na obrazovce }
                    procedure _Presun_Rel(X, Y, Z : Typ_Souradnic);virtual;
                    constructor Init;
                  end;

type Typ_Hvezda = object(Typ_Hejbaci)
                    _Velikost      : Typ_Souradnic;
                    _Smer1, _Smer2 : Boolean;
                    procedure Vytvor(Velikost : Byte; _Barva : Byte; Znak : Char);
                    procedure _Zobraz; virtual;
                     { vytvo kopii objektu v obrazovce }
                    procedure _Zhasni; virtual;
                     { zhasne objekt na obrazovce }
                    constructor Init;
                    procedure Vm0;virtual;
                    procedure Vm1;virtual;
                  end;

implementation

procedure Typ_Hvezda.Vytvor(Velikost : Byte; _Barva : Byte; Znak : Char);
var Pom : Bod_Fyz_Obrazu;
      I : Integer;
begin
  Zhasni;
  if Velikost < 2 then Velikost := 1;

  _Velikost := Velikost;

  _Get_Mem_Tvar(18);

  Pom.Atrib := _Barva;
  Pom.Znak  := Znak;

  for I := 0 to 17 do set_Bod(I, Pom);
end;

procedure Typ_Hvezda.Vm0;
begin
  Zhasni;
      if _Smer1
        then if _Velikost < 7
               then Inc(_Velikost)
               else _Smer1 := False
        else if _Velikost > 1
               then Dec(_Velikost)
               else _Smer1 := True;
  Zobraz;
end;

procedure Typ_Hvezda.Vm1;
var _At     : Byte;
    I       : Word;
begin
      _At := Dej_Bod(0)^.Obsah.Atrib;
      if _Smer2
        then if _At < 16
               then begin Inc(_At);
                            for I := 0 to Obsazeno -1 do
                              set_Bod_Barva(I, _At); end
               else _Smer2 := False
        else if _At > 0
               then begin Dec(_At);
                          for I := 0 to Obsazeno-1 do
                            set_Bod_Barva(I, _At); end
               else _Smer2 := True;
end;

procedure Typ_Hvezda._Zobraz;
var X, Y, Z : Typ_Souradnic;
    Pom     : Typ_Bod_3D;
begin
  if _Velikost <> 0 then
    begin

      X := Poloha.X;
      Y := Poloha.Y;
      Z := Poloha.Z;
      Pom := Dej_Bod(0);
      Obrazovka.Zobraz_Bod_Xy(X-_Velikost shl 1, Y-_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X,                 Y-_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X+_Velikost shl 1, Y-_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));

      Obrazovka.Zobraz_Bod_Xy(X-_Velikost, Y-_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X,           Y-_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X+_Velikost, Y-_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));

      Obrazovka.Zobraz_Bod_Xy(X-_Velikost shl 1,    Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X-_Velikost,          Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X,                    Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X+_Velikost,          Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X+_Velikost shl 1,    Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));

      Obrazovka.Zobraz_Bod_Xy(X-_Velikost,    Y+_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X,                    Y+_Velikost , Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X+_Velikost,      Y+_Velikost , Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));


      Obrazovka.Zobraz_Bod_Xy(X-_Velikost shl 1, Y+_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X,                 Y+_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zobraz_Bod_Xy(X+_Velikost shl 1, Y+_Velikost shl 1, Pom);
    end;
end;

procedure Typ_Hvezda._Zhasni;
var X, Y, Z : Typ_Souradnic;
    Pom     : Typ_Bod_3D;
begin
  if _Velikost <> 0 then
    begin
      X := Poloha.X;
      Y := Poloha.Y;
      Z := Poloha.Z;
      Pom := Dej_Bod(0);
      Obrazovka.Zhasni_Bod_Xy(X-_Velikost shl 1, Y-_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X,                 Y-_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X+_Velikost shl 1, Y-_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));

      Obrazovka.Zhasni_Bod_Xy(X-_Velikost, Y-_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X,           Y-_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X+_Velikost, Y-_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));

      Obrazovka.Zhasni_Bod_Xy(X-_Velikost shl 1,    Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X-_Velikost,          Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X,                    Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X+_Velikost,          Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X+_Velikost shl 1,    Y, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));

      Obrazovka.Zhasni_Bod_Xy(X-_Velikost,    Y+_Velikost, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X,                    Y+_Velikost , Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X+_Velikost,      Y+_Velikost , Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));


      Obrazovka.Zhasni_Bod_Xy(X-_Velikost shl 1, Y+_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X,                 Y+_Velikost shl 1, Pom);
      Inc(Word(Pom),SizeOf(Typ_Ob_Bodu));
      Obrazovka.Zhasni_Bod_Xy(X+_Velikost shl 1, Y+_Velikost shl 1, Pom);
    end;
end;

constructor Typ_Hvezda.Init;
begin
  Typ_Hejbaci.Init;
  _Velikost := 0;
  _Smer1 := True;
  _Smer2 := True;
end;


procedure Typ_Kriz.Vytvor(Velikost : Byte; _Barva : Byte;  Typ : Vzhled_Kriz);
var I, Pompam : Word;
begin
  if Velikost < 2 then Velikost := 2;

  _Velikost := Velikost;

  Pompam    := ((Velikost*2-1)*2-1);
  _Get_Mem_Tvar(Pompam);

  for I := Velikost*2   to Velikost*3-3 do set_Bod_Znak(I, Typ[6]);
  for I := Velikost     to Velikost*2-3 do set_Bod_Znak(I, Typ[7]);
  for I := Velikost*3-2 to Velikost*4-5 do set_Bod_Znak(I, Typ[8]);
  for I := 1            to Velikost*1-2 do set_Bod_Znak(I, Typ[9]);

  set_Bod_Znak(Velikost*2-1, Typ[1]);
  set_Bod_Znak(Velikost*2-2, Typ[2]);
  set_Bod_Znak(Velikost*4-4, Typ[3]);
  set_Bod_Znak(           0, Typ[4]);

  set_Bod_Znak(Velikost*1-1, Typ[5]);

  for I := 0 to Pompam - 1 do set_Bod_Barva(I, _Barva);
end;

procedure Typ_Kriz._Presun_Rel(X, Y, Z : Typ_Souradnic);
var Pom    : Typ_Bod_3D;  {v obrazovce a na jeho z-souradnici}
    I      : Typ_Souradnic;
    Px1, Py1, Px2, Py2 : Shortint;

begin
      Px1 := Poloha.X;
      Py1 := Poloha.Y;
      Px2 := X;
      Py2 := Y;

      Pom := Dej_Bod(0);
      for I := Px1 to Px1+_Velikost*2-2 do
        begin
          Pom^.Z := Poloha.Z;
          Obrazovka.Presun_Bod_Xy(I, _Velikost-1+Py1, I+Px2, _Velikost-1+Py1+Py2, Pom);
          Inc(Word(Pom),SizeOf(Typ_Ob_Bodu))
        end;

      for I := Py1 to Py1+_Velikost-2 do
        begin
          Pom^.Z := Poloha.Z;
          Obrazovka.Presun_Bod_Xy(_Velikost-1+Px1, I, _Velikost-1+Px1+Px2, I+Py2,  Pom);
          Inc(Word(Pom),SizeOf(Typ_Ob_Bodu))
        end;

      for I := Py1+_Velikost to Py1+_Velikost*2-2 do
        begin
          Pom^.Z := Poloha.Z;
          Obrazovka.Presun_Bod_Xy(_Velikost-1+Px1, I,_Velikost-1+Px1+Px2, I+Py2,  Pom);
          Inc(Word(Pom),SizeOf(Typ_Ob_Bodu))
        end;

  Inc(Poloha.X, X);
  Inc(Poloha.Y, Y);
  Inc(Poloha.Z, Z);
end;



procedure Typ_Kriz._Zobraz;
var Pom    : Word;  {v obrazovce a na jeho z-souradnici}
    I      : Typ_Souradnic;
    Px, Py : Shortint;

begin
  Px := Poloha.X;
  Py := Poloha.Y;
  Pom := 0;
  for I := Px to Px+_Velikost*2-2 do
    begin
      set_Bod_Z(Pom, Poloha.Z);
      Obrazovka.Zobraz_Bod_Xy(I, _Velikost-1+Py, Dej_Bod(Pom));
      Inc(Pom)
    end;

  for I := Py to Py+_Velikost-2 do
    begin
      set_Bod_Z(Pom, Poloha.Z);
      Obrazovka.Zobraz_Bod_Xy(_Velikost-1+Px, I, Dej_Bod(Pom));
      Inc(Pom)
    end;

  for I := Py+_Velikost to Py+_Velikost*2-2 do
    begin
      set_Bod_Z(Pom, Poloha.Z);
      Obrazovka.Zobraz_Bod_Xy(_Velikost-1+Px, I, Dej_Bod(Pom));
      Inc(Pom)
    end;
end;

procedure Typ_Kriz._Zhasni;
var Pom    : Word;  {v obrazovce a na jeho z-souradnici}
    I      : Typ_Souradnic;
    Px, Py : Shortint;

begin
  Px := Poloha.X;
  Py := Poloha.Y;
  Pom := 0;
  for I := Px to Px+_Velikost*2-2 do
    begin
      Obrazovka.Zhasni_Bod_Xy(I, _Velikost-1+Py, Dej_Bod(Pom));
      Inc(Pom)
    end;

  for I := Py to Py+_Velikost-2 do
    begin
      Obrazovka.Zhasni_Bod_Xy(_Velikost-1+Px, I, Dej_Bod(Pom));
      Inc(Pom)
    end;

  for I := Py+_Velikost to Py+_Velikost*2-2 do
    begin
      Obrazovka.Zhasni_Bod_Xy(_Velikost-1+Px, I, Dej_Bod(Pom));
      Inc(Pom)
    end;
end;



constructor Typ_Kriz.Init;
begin
  Typ_Hejbaci.Init;
  _Velikost := 0;
end;

end.
