{$G+}
unit Unobdel;

interface

uses Obraz3D, Unhejb;
type
  Typ_Ramu = array[1..8]of Char;

const
  Strom_Ram      : Typ_Ramu = ('','','','','','','','');
  Prazdny_Ram    : Typ_Ramu = (' ',' ',' ',' ',' ',' ',' ',' ');
  Obyc_Ram       : Typ_Ramu = ('','','','','','','','');
  Zv_Horni_Ram   : Typ_Ramu = ('','','','','','','','');
  Doubble_Ram    : Typ_Ramu = ('','','','','','','','');

type Typ_Obdelnik = object(Typ_Hejbaci)
                    Rozmer : _Bod2D;
                    procedure Vytvor_Ram(X1, Y1 : Typ_Souradnic;
                                     Pombarva1, Pombarva2 : Byte;
                                     var Typ);
                    procedure Vytvor(X1, Y1 : Typ_Souradnic; Pombarva : Byte);
                    procedure _Ram(var Typ; Pombarva : Byte);
                     { vytvo rm pedchozho }
                    procedure Cejch_Ram(var Typ; Pombarva : Byte;
                               Vrch, Dol : string);
                     { vytvo 'ocejchovan' rm pedchozho : }
                     { VrchĿ                               }
                     {  Krt                                  }
                     { Dol                               }

                    procedure Presun_Rel(X, Y, Z : Typ_Souradnic);virtual;
                    procedure _Zobraz; virtual;
                     { vytvo kopii objektu v obrazovce }
                    procedure _Zhasni; virtual;
                     { zhasne objekt na obrazovce }
                    procedure _Obnov; virtual;
                     { obnov objekt na obrazovce }
                  end;
     Typ_Line = object(Typ_Obdelnik)
                    procedure Vytvor_string_Ram(S : string;
                                         Pombarva1, Pombarva2 : Byte; var Typ);
                     { vytvo ormovan objekt : (S = ' Krt' }
                     { Ŀ  PomBarva1 - barva vnitku      }
                     { S        PomBarva2 - barva rmu         }
                     {                               }
                     {  Typ - pole char v poad :            }
                     {      '','','','','','','',''   }
                    procedure _Vnitrek(S : string; Pombarva : Byte);
                     { vytvo vnitek pedchozho }
                end;

     Typ_Integer = object(Typ_Line)
                     procedure Vytvor(I, K : Integer; C1, C2 : Byte; var Typ);
                   end;


     Typ_string = object(Typ_Line)
                    procedure Vytvor(S : string; Pombarva : Byte);
                     { vytvo objekt na souadnicch [x,y,z] }
                     { jeho obah je dan string o dan barv }
                  end;
implementation

procedure Typ_Integer.Vytvor;
var Sss : string[6];
begin
  Str(I:K,Sss);
  Vytvor_string_Ram(Sss, C1, C2, Typ)
end;

procedure Typ_Obdelnik.Vytvor(X1, Y1 : Typ_Souradnic; Pombarva : Byte);
begin
  Zhasni;
  Rozmer.X := X1-1;
  Rozmer.Y := Y1-1;
  Barva := Pombarva;
  _Get_Mem_Tvar((Rozmer.X+1)*(Rozmer.Y+1));
end;

procedure Typ_Obdelnik.Vytvor_Ram(X1,Y1 : Typ_Souradnic;
                               Pombarva1, Pombarva2 : Byte; var Typ);
begin
  Vytvor(X1, Y1, Pombarva1);
  _Ram(Typ, Pombarva2);
end;

procedure Typ_string.Vytvor(S : string;  Pombarva : Byte);
{ bez ramu }
var  I : Integer;
begin
  Zhasni;     
  Barva := Pombarva;
  Rozmer.X := Ord(S[0])-1;
  Rozmer.Y := 0;
  _Get_Mem_Tvar((Rozmer.X+1)*(Rozmer.Y+1));
  for I := 0 to Ord(S[0])-1 do Tvar^.Tvar[I].Obsah.Atrib := Pombarva;
  for I := 0 to Ord(S[0])-1 do Tvar^.Tvar[I].Obsah.Znak  := S[I+1];
end;

procedure Typ_Obdelnik.Cejch_Ram(var Typ; Pombarva : Byte; Vrch, Dol : string);
var B1, B2 : Bod_Fyz_Obrazu;
    I, Pom : Word;
    Px, Py : Byte;
begin
  Barva := Pombarva;
  Px := Rozmer.X + 1;
  Py := Rozmer.Y + 1;
  Pom := Rozmer.Y*Px;
  B1.Atrib := Pombarva;
  B2.Atrib := Pombarva;

  B1.Znak  :=  Typ_Ramu(Typ)[5]; {''};
  B2.Znak  :=  Typ_Ramu(Typ)[7]; {''};
  for I := 0 to Rozmer.X do
    begin
      Tvar^.Tvar[I].Obsah     := B1;
      Tvar^.Tvar[I+Pom].Obsah := B2;
    end;

  B1.Znak :=  Typ_Ramu(Typ)[8]; {''}
  B2.Znak :=  Typ_Ramu(Typ)[6]; {''}
  I := Px;
  while I <= Pom do
    begin
      Tvar^.Tvar[I].Obsah          := B1;
      Tvar^.Tvar[I+Rozmer.X].Obsah := B2;
      Inc(I, Px)
    end;

  if Vrch <> '' then
    for I := 1 to Byte(Vrch[0]) do
      Tvar^.Tvar[I].Obsah.Znak := Vrch[I];
  if Dol <> '' then
    for I := 1 to Byte(Vrch[0]) do
      Tvar^.Tvar[I+Pom].Obsah.Znak := Dol[I];

  Tvar^.Tvar[0].Obsah.Znak                := Typ_Ramu(Typ)[1]; {''}
  Tvar^.Tvar[Rozmer.X].Obsah.Znak         := Typ_Ramu(Typ)[2]; {''}
  Tvar^.Tvar[Pom+Rozmer.X].Obsah.Znak     := Typ_Ramu(Typ)[3]; {''}
  Tvar^.Tvar[Pom].Obsah.Znak              := Typ_Ramu(Typ)[4]; {''}
  Obnov;
end;

procedure Typ_Obdelnik._Ram(var Typ; Pombarva : Byte);
begin
  Cejch_Ram(Typ, Pombarva, '', '');
end;

procedure Typ_Line._Vnitrek(S : string; Pombarva : Byte);
var I : Byte;
    Bz : Boolean;
begin
  Bz := False;
  if __Videt and Stav <> 0  then
    begin
      Zhasni;
      Bz := True
    end;
  for I:=0 to Ord(S[0])-1 do
    begin
      Tvar^.Tvar[Rozmer.X+I+2].Obsah.Znak := S[I+1];
      Tvar^.Tvar[Rozmer.X+I+2].Obsah.Atrib := Pombarva
    end;
  if Bz then Zobraz;
end;

procedure Typ_Line.Vytvor_string_Ram(S : string;
                                Pombarva1, Pombarva2 : Byte; var Typ);
var P : Boolean;
{vytvori vzhled prvku, t.j. oramovany retez znaku}
{ramecek viz init}
begin
  P := False;
  if (Stav and __Videt) <> 0 then begin Zhasni; P:= True; end;
  Rozmer.X := Ord(S[0])+1;
  Rozmer.Y := 2;
  _Get_Mem_Tvar((Rozmer.X+1)*(Rozmer.Y+1));
  _Ram(Typ, Pombarva1);
  _Vnitrek(S, Pombarva2);
  if P then Zobraz;
end;

procedure Typ_Obdelnik.Presun_Rel(X, Y, Z : Typ_Souradnic);
label N1, N2, Je_Mensi, Dalsi1, Dalsi_Bod, Nevidet, Konec, Konecr, Konecs, Jenom_Presun,
      Konec_Proc, Blbl, Nez_Seg1, Nez_Seg2;
var Adrobj1, Adrobj2, I : Integer;  {v obrazovce a na jeho z-souradnici}
    Nb           : Typ_Bod_3D;
      { normalizovana adresa presouvaneho bodu, stejna pro oba }
    _Fo1         : Pointer;
      { na. adresa ruseneho ve fyz. obraze }
    _Fo2         : Pointer;
      { na. adresa nastavovaneho ve fyz. obraze }
    _3do1        : Typ_Bod_3D;
      { na. adresa ruseneho v 3D obraze }
    _3do2        : Typ_Bod_3D;
      { adresa nastavovaneho v 3D obraze }
    _Xfyz        : Word;
      { sirka fyz. obrazovky - rozmer.x v byte }
    _X3D         : Word;
      { sirka 3D obrazovky - rozmer.x v Byte  }
    Rx, Ry       : Word;
      { rozmery objektu }
    _Xar, _Xarc, _Yar, _Xas, _Xasc, _Yas, _Xobr, _Yobr : Byte;
begin
    Inc(X, Poloha.X);
    Inc(Y, Poloha.Y);
    Inc(Z, Poloha.Z);

    Asm
                 Les Di, Self

                 Test Es:[Di].Stav, __Videt
                 Jz Jenom_Presun

                 or  Es:[Di].Stav, __Zobrazuje_Se { objekt se bude zobrazovat }

                 Mov Al, Obrazovka.X_Obr;
                 Mov _Xobr, Al
                 Mov Al, Obrazovka.Y_Obr;
                 Mov _Yobr, Al

                 Push Ds

                 Les Di, Self

          { Adrobj1 := (Obrazovka.X_Obr*(Poloha.Y+Poloha.Z))+Poloha.X-Poloha.Z;}

                 Mov Al, Es:[Di].Poloha.Y
                 Cbw                       { Y }
                 Mov Dx, Ax
                 Mov Al, Es:[Di].Poloha.Z
                 Cbw
                 Mov Bx, Ax                { bx = Z }
{&&&                 Add Dx, Ax                { +Z }
                 Mov _Yar, Dl;
                 Mov Al, Obrazovka.X_Obr
                 xor Ah, Ah
                 Imul Dx                   { *X_Obr }
                 Mov Cx, Ax
                 Mov Al, Es:[Di].Poloha.X
                 Cbw
                 Mov Dx, Ax
{     &&&            Sub Dx, Bx}
                 Mov _Xar,  Dl
                 Mov _Xarc, Dl
                 Add Cx, Dx
                 Mov Adrobj1, Cx

          { Adrobj2 := (Obrazovka.X_Obr*(Y+Z))+X-Z;}
                 Mov Al, Y
                 Cbw                       { Y }
                 Mov Dx, Ax
                 Mov Al, Z
                 Cbw
                 Mov Bx, Ax                { bx = Z }
{&&&                 Add Dx, Ax                { +Z }
                 Mov _Yas, Dl
                 Mov Al, Obrazovka.X_Obr
                 xor Ah, Ah
                 Imul Dx                   { *X_Obr }
                 Mov Cx, Ax
                 Mov Al, X
                 Cbw
                 Mov Dx, Ax
{&&&                Sub Dx, Bx}
                 Mov _Xas, Dl
                 Mov _Xasc, Dl
                 Add Cx, Dx
                 Mov Adrobj2, Cx

                 Mov Ax, Adrobj1
                 Les Di, Obrazovka.Fyz_Obraz { ulozeni adresy 1. pixelu }
                 Add Ax, Ax
                 Add Di, Ax
{ fo1 }          Mov Word Ptr _Fo1, Di
                 Mov Word Ptr _Fo1+2, Es

                 Mov Ax, Adrobj2
                 Les Di, Obrazovka.Fyz_Obraz { ulozeni adresy 1. pixelu }
                 Add Ax, Ax
                 Add Di, Ax
{ fo2 }          Mov Word Ptr _Fo2, Di
                 Mov Word Ptr _Fo2+2, Es

                 xor Ah,Ah     { ulozi rx, dx }
                 Mov Al, Obrazovka.X_Obr
                 Les Di, Self
                 xor Dh, Dh
                 Mov Dl, Es:[Di].Rozmer.Y
                 Inc Dl
{ ry }           Mov Word Ptr Ry, Dx
                 Mov Dl, Es:[Di].Rozmer.X
                 Inc Dl
{ rx }           Mov Rx, Dx
{ i }            Mov I, Dx
                                   { ulozi xfyz a x3d }
                 Sub Ax, Dx        { dx .. rozmer.x }
                 shl Ax, 1
{ _xfyz }        Mov _Xfyz, Ax
                 Mov Dx, 3
                 Mul Dx
{ x3d }          Mov _X3D, Ax

                 Les Di, Es:[Di].Tvar
                 Lea Di, Typ_Tvar([Di]).Tvar { es : di presouvany bod }
                 Mov Ax, Di  { normalisace adresy }
                 and Di, 0Fh
                 shr Ax, 4
                 Mov Dx, Es
                 Add Ax, Dx
                 Mov Es, Ax

{ nb }           Mov Word Ptr Nb, Di
                 Mov Word Ptr Nb+2, Ax

                 Lds Si, Obrazovka.__Obraz { do ds:si adresa bodu    }
                 Mov Ax, Adrobj1           { v 3D obraze a jeji      }
                 Mov Dx, Pamet_Bod_3D
                 Imul Dx
                 Add Si, Ax

{ _3do1 }        Mov Word Ptr _3do1, Si  { bod1 nahran }
                 Mov Word Ptr _3do1+2, Ds

                 Pop  Ds
                 Push Ds

                 Lds Si, Obrazovka.__Obraz { do ds:si adresa bodu    }
                 Mov Ax, Adrobj2           { v 3D obraze a jeji      }
                 Mov Dx, Pamet_Bod_3D      { normalizace             }
                 Imul Dx
                 Add Si, Ax
                 Mov Ax, Si             { normalizace adresy }
                 and Si, 0Fh
                 Sar Ax, 4
                 Mov Dx, Ds
                 Add Ax, Dx

{ 3do2 }         Mov Word Ptr _3do2, Si  { bod2 nahran }
                 Mov Word Ptr _3do2+2, Ax

   { begin vymazbod }


   Dalsi_Bod :   Mov Cl, _Xarc
                 Cmp Cl, 0
                 Js Konecr
                 Cmp Cl, _Xobr
                 Jge Konecr
                 Mov Bl, _Yar
                 Cmp Bl, 0
                 Js Blbl{Konecr}
                 Cmp Bl, _Yobr
                 Jge Konecr

                 Lds Si, _3do1
                 Les Di, Nb

                   { ds:[si] odkud rusit, nenorm. }
                   { es:[di] kterej rusit, norm. }
                 Mov Ax, Es

   Dalsi1:       Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Test Ds:Typ_Ob_Bodu([Si]).Typ, _Pozadi { je to pozad ? }
                 Jnz Konecr               { ne - to, co se ma ruit, v seznamu nejni }

                 Mov Cx, Ds
                 Cmp Cx, Ax               { sou stejn segmenty ? }
                 Jne Dalsi1               { nejsou ! }
                 Cmp Si, Di               { sou stejny offsety ? }
                 Jne Dalsi1               { nejsou ! }

                   { ds:si es:di oba ruseny bod }
                   { dx:bx bod pred nim         }
                 Lds Si, Ds:[Si]         { pointer z ds:[si] se pesune na dx:[bx] }
                 Mov Ax, Ds
                 Mov Ds, Dx
                 Mov Cx, Ds:[Bx]
                 and Cl,0F0H
                 and Si,0Fh
                 or Cx, Si
                 Mov Ds:[Bx], Cx
                 Mov Ds:[Bx+2], Ax

                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konecr

                 Lds Bx, Ds:[Bx]
                 and Bx, 0Fh
                 Mov Ax, Ds:Typ_Ob_Bodu([Bx]).Obsah { bod byl vidt, na obrazovku mus nsledujc za tmto }
                 Lds Si, _Fo1

{$ifdef OUTBIOS}
                 Push Ax
                 Push Bx
                 Push Cx
                 Push Dx

                 Push Si
                 Push Di

                 Push Ds
                 Push Es

                 Push Ax
                 Mov Bh, Stranka
                 Mov Dh, _Yar
                 Mov Dl, _Xarc
                 Mov Ah, 2
                 Int 010H

                 Pop Dx

                 Mov Al, Dl
                 Mov Bl, Dh
                 Mov Bh, Stranka
                 Mov Ah, 09H
                 Mov Cx, 01H
                 Int 010H

                 Pop Es
                 Pop Ds

                 Pop Di
                 Pop Si

                 Pop Dx
                 Pop Cx
                 Pop Bx
                 Pop Ax

{$else}
                 Mov Ds:[Si], Ax
{$endif}
                 Jmp Konecr

    Blbl:        Mov Ax, Ax

   Konecr:
     { begin set_bod }
                 Mov Cl, _Xasc
                 Cmp Cl, 0
                 Js Konecs
                 Cmp Cl, _Xobr
                 Jge Konecs
                 Mov Bl, _Yas
                 Cmp Bl, 0
                 Js Konecs
                 Cmp Bl, _Yobr
                 Jge Konecs

                 { es:[di] je nb z predchoziho }

                 Lds Si, _3do2
                 Les Di, Nb

                 Mov Al, Z
                 Mov Es:Typ_Ob_Bodu([Di]).Z, Al

                 Mov Ax, Es:[Di]          { typ a loadr noveho bodu do AL, Z noveho bodu do AH }
                 and Al, 0F0H             { loadr = 0 }

   Je_Mensi:     Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Cmp Ah, Ds:Typ_Ob_Bodu([Si]).Z
                 Jl Je_Mensi

                 or  Si, Ax               { pridani adresy dalsiho }
                 Mov Es:[Di], Si          { prehozeni pointeru, novy prvek -> dalsi }
                 Mov Si, Ds
                 Mov Es:[Di+2], Si

                 Mov Ds, Dx               { predchozi -> novy }
                 Mov Ax, Ds:[Bx]
                 and Al, 0F0H
                 or Ax, Di
                 Mov Ds:[Bx], Ax
                 Mov Si, Es
                 Mov Ds:[Bx+2], Si

                 Mov Ds, Dx
                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Konecs

                 { nov bod m bt vidt }
                 Mov Ax, Es:Typ_Ob_Bodu([Di]).Obsah
                 Lds Si, _Fo2

{$ifdef OUTBIOS}
                 Push Ax
                 Push Bx
                 Push Cx
                 Push Dx

                 Push Si
                 Push Di

                 Push Ds
                 Push Es

                 Push Ax
                 Mov Bh, Stranka
                 Mov Dh, _Yas
                 Mov Dl, _Xasc
                 Mov Ah, 2
                 Int 010H
                 Pop Dx

                 Mov Al, Dl
                 Mov Bl, Dh
                 Mov Bh, Stranka
                 Mov Ah, 09H
                 Mov Cx, 01H
                 Int 010H

                 Pop Es
                 Pop Ds

                 Pop Di
                 Pop Si

                 Pop Dx
                 Pop Cx
                 Pop Bx
                 Pop Ax

{$else}
                 Mov Ds:[Si], Ax
{$endif}

    Konecs:      { zvetsit adresy _fo1, _fo2 o 2 }
                 { zvetsit adresy _3do1, _3do2, nb o 2 }
                 { zvetsit _xasc, _xarc o 1 }

                 Inc _Xasc
                 Inc _Xarc

{ _3do1 }        Add Word Ptr _3do1, Pamet_Bod_3D

    Nez_Seg1:    Les Bx, _3do2
                 Add Bl, Pamet_Bod_3D
                 Cmp Bl, 10H
                 Jl N1
                 Sub Bl, 10H
                 Mov Ax, Es
                 Inc Ax
                 Mov Es, Ax
{ _3do2 } N1:    Mov  Word Ptr _3do2, Bx
                 Mov  Word Ptr _3do2+2, Es

                 Les Bx, Nb
                 Add Bl, Pamet_Bod_3D
                 Cmp Bl, 10H
                 Jl N2
                 Sub Bl, 10H
                 Mov Ax, Es
                 Inc Ax
                 Mov Es, Ax
{ nb }    N2:    Mov  Word Ptr Nb, Bx
                 Mov  Word Ptr Nb+2, Es

{ _fo1 }         Add Word Ptr _Fo1, 2

{ _fo2 }         Add Word Ptr _Fo2, 2

                 Dec I
                 Jnz Dalsi_Bod    { v radku }

                 Mov Ax, Rx
                 Mov I, Ax
                 Mov Al, _Xar
                 Mov _Xarc, Al
                 Mov Al, _Xas
                 Mov _Xasc, Al

                 { zvetsit adresy _fo1, _fo2 o _xfyz }
                 { zvetsit adresy _3do1, _3do2 o _x3d }
                 { zvetsit _yar, _yas o 1}
                 Inc _Yar
                 Inc _Yas

                 Mov Dx, _Xfyz
                 Add Word Ptr _Fo1, Dx
                 Add Word Ptr _Fo2, Dx

                 Mov Ax, _X3D
                 Add Word Ptr _3do1, Ax

                 Lds Si, _3do2
                 Add Si, _X3D
                 Mov Ax, Si             { normalizace adresy }
                 and Si, 0Fh
                 shr Ax, 4
                 Mov Dx, Ds
                 Add Ax, Dx
                 Mov Ds, Ax
                 Mov Word Ptr _3do2, Si
                 Mov Word Ptr _3do2+2, Ds

                 Dec Ry
                 Jnz Dalsi_Bod
    Konec:       Pop Ds
  end;
  Jenom_Presun:
  Poloha.X := X;
  Poloha.Y := Y;
  Poloha.Z := Z;
  Asm
                 Les Di, Self                     { nastaveni atribut }
                 and Es:[Di].Stav, __Zobrazuje_Se xor 0Ffh { uz se nezobrazuje }
  end;
  Konec_Proc:
end;

procedure Typ_Obdelnik._Zobraz;  {zobrazi natvrdo objekt na jeho misto }
label N1, N2, Je_Mensi, Dalsi, Nevidet, Konec;
var Adrobj, I    : Integer;  {v obrazovce a na jeho z-souradnici}
    Nb           : Typ_Bod_3D;
      { normalizovana adresa dalsiho bodu }
    Fo           : Pointer;
      { adresa leveho sloupce ve fyz. obraze }
    _do          : Typ_Bod_3D;
      { adresa leveho sloupce v 3D obraze }
    _Xfyz        : Word;
      { sirka fyz. obrazovky - rozmer.x v byte }
    _X3D         : Word;
      { sirka 3D obrazovky - rozmer.x v Byte  }
    _Z           : Shortint;
      { z - souradnice tohoto objektu }
    Rx, Ry       : Word;
      { rozmery objektu }
    _Xar, _Xarc, _Yar, _Xobr, _Yobr : Byte;

begin
  Asm


                 Mov Al, Obrazovka.X_Obr;
                 Mov _Xobr, Al
                 Mov Al, Obrazovka.Y_Obr;
                 Mov _Yobr, Al


                 Les Di, Self

          { Adrobj1 := (Obrazovka.X_Obr*(Poloha.Y+Poloha.Z))+Poloha.X-Poloha.Z;}

                 Mov Al, Es:[Di].Poloha.Y
                 Cbw                       { Y }
                 Mov Dx, Ax
                 Mov Al, Es:[Di].Poloha.Z
                 Cbw
                 Mov Bx, Ax                { bx = Z }
{&&&                 Add Dx, Ax                { +Z }
{_Yar}           Mov _Yar, Dl;
                 Mov Al, Obrazovka.X_Obr
                 xor Ah, Ah
                 Imul Dx                   { *X_Obr }
                 Mov Cx, Ax
                 Mov Al, Es:[Di].Poloha.X
                 Cbw
                 Mov Dx, Ax
{&&&                 Sub Dx, Bx}
{_Xar}           Mov _Xar,  Dl
{_Xarc}          Mov _Xarc, Dl
                 Add Cx, Dx
                 Mov Adrobj, Cx

                 Mov Ax, Adrobj
                 Les Di, Obrazovka.Fyz_Obraz { ulozeni adresy 1. pixelu }
                 Add Ax, Ax
                 Add Di, Ax
{Fo}             Mov Word Ptr Fo, Di
                 Mov Word Ptr Fo+2, Es

                 xor Ah,Ah     { ulozi rx, dx }
                 Mov Al, Obrazovka.X_Obr
                 Les Di, Self
                 xor Dh, Dh
                 Mov Dl, Es:[Di].Rozmer.Y
                 Inc Dl
{Ry}             Mov Word Ptr Ry, Dx
                 Mov Dl, Es:[Di].Rozmer.X
                 Inc Dl
{Rx}             Mov Word Ptr Rx, Dx

                                   { ulozi xfyz a x3d }
                 Sub Ax, Dx        { dx .. rozmer.x ? }
                 Mov Dx, 2
                 Mul Dx
{_Xfyz}          Mov _Xfyz, Ax
                 Mov Dx, 3
                 Mul Dx
{_X3D}           Mov _X3D, Ax

                 Mov Al, Es:[Di].Poloha.Z
{_Z}             Mov _Z, Al
      end;
                 Nb := @Tvar^.Tvar;
      Asm
                 Les Di, Nb  { es : di pridavany bod }
                 Mov Ax, Di  { normalisace adresy }
                 and Di, 0Fh
                 shr Ax, 4
                 Mov Dx, Es
                 Add Ax, Dx
                 Mov Es, Ax

{Nb}             Mov Word Ptr Nb, Di
                 Mov Word Ptr Nb+2, Ax

                 Push Ds

                 Lds Si, Obrazovka.__Obraz { do ds:si adresa bodu    }
                 Mov Ax, Adrobj            { v 3D obraze a jeji      }
                 Mov Dx, Pamet_Bod_3D      { normalizace             }
                 Imul Dx
                 Add Si, Ax
                 Mov Ax, Si             { normalizace adresy }
                 and Si, 0Fh
                 Sar Ax, 4
                 Mov Dx, Ds
                 Add Ax, Dx
                 Mov Ds, Ax

{_do}            Mov Word Ptr _do, Si
                 Mov Word Ptr _do+2, Ds

                 Mov Ax, Rx
{I}              Mov I, Ax

                 { set_bod }
   Dalsi:        Mov Cl, _Xarc
                 Cmp Cl, 0
                 Js Nevidet
                 Cmp Cl, _Xobr
                 Jge Nevidet
                 Mov Bl, _Yar
                 Cmp Bl, 0
                 Js Nevidet
                 Cmp Bl, _Yobr
                 Jge Nevidet

                 Mov Al, _Z
                 Mov Es:Typ_Ob_Bodu([Di]).Z,Al
                 or Es:Typ_Ob_Bodu([Di]).Typ, _Pouzit { bod bude pouzit }

                 Mov Ax, Es:[Di]          { typ a loadr noveho bodu do AL, z noveho bodu do AH }
                 and Al, 0F0H             { loadr = 0 }

    Je_Mensi:    Mov Bx, Si               { uloen star adresy }
                 Mov Dx, Ds
                 Lds Si, Ds:[Si]          { adresa dalho prvku }
                 and Si, 0Fh

                 Cmp Ah, Ds:Typ_Ob_Bodu([Si]).Z
                 Jl Je_Mensi

                 or  Si, Ax               { pridani adresy dalsiho }
                 Mov Es:[Di], Si          { prehozeni pointeru, novy prvek -> dalsi }
                 Mov Si, Ds
                 Mov Es:[Di+2], Si

                 Mov Ds, Dx               { predchozi -> novy }
                 Mov Ax, Ds:[Bx]
                 and Al, 0F0H
                 or Ax, Di
                 Mov Ds:[Bx], Ax
                 Mov Si, Es
                 Mov Ds:[Bx+2], Si

                 Mov Ds, Dx
                 Test Ds:Typ_Ob_Bodu([Bx]).Typ, _Pozadi
                 Jz Nevidet

                 { nov bod m bt vidt }
                 Mov Ax, Es:Typ_Ob_Bodu([Di]).Obsah
                 Lds Si, Fo
                 Mov Ds:[Si], Ax

                 { zvetsit adresy fo, _do, nb o pamet_bod_3d}
     Nevidet:    Inc _Xarc
                 Add Word Ptr  Fo, 2

                 Lds Bx, _do
                 Add Bl, Pamet_Bod_3D
                 Cmp Bl, 10H
                 Jl N1
                 Sub Bl, 10H
                 Mov Ax, Ds
                 Inc Ax
                 Mov Ds, Ax
          N1:    Mov Si, Bx
                 Mov  Word Ptr _do, Bx
                 Mov  Word Ptr _do+2, Ds

                 Les Bx, Nb
                 Add Bl, Pamet_Bod_3D
                 Cmp Bl, 10H
                 Jl N2
                 Sub Bl, 10H
                 Mov Ax, Es
                 Inc Ax
                 Mov Es, Ax
          N2:    Mov Di, Bx
                 Mov  Word Ptr Nb, Bx
                 Mov  Word Ptr Nb+2, Es

                 Dec I
                 Jnz Dalsi

                 Mov Ax, Rx
                 Mov I, Ax
                 Mov Al, _Xar
                 Mov _Xarc, Al

                 { zvetsit adresy fo a _do o dalsi radek }
                 Inc _Yar

                 Mov Dx, _Xfyz
                 Add Word Ptr Fo, Dx

                 Lds Si, _do
                 Add Si, _X3D
                 Mov Ax, Si             { normalizace adresy }
                 and Si, 0Fh
                 shr Ax, 4
                 Mov Dx, Ds
                 Add Ax, Dx
                 Mov Ds, Ax

                 Mov Word Ptr _do, Si
                 Mov Word Ptr _do+2, Ds


                 Dec Ry
                 Jnz Dalsi

                 Pop Ds                 { konec zobraz }

    end;
Konec:
end;

procedure Typ_Obdelnik._Obnov;
var I, J, Z : Typ_Souradnic;
    Pom  : Typ_Bod_3D;


begin
  if (Stav and __Videt) <> 0 then
    begin
      Pom := @Tvar^.Tvar[0];
      Z := Poloha.Z;
      for I := Poloha.Y{&&&+Z} to Poloha.Y+Rozmer.Y{&&&+Z} do
        for J := Poloha.X{&&&-Z} to Poloha.X+Rozmer.X{&&&-Z} do
          begin
            Obrazovka.Obnov_Bod_Xy(J, I);
            Inc(Word(Pom), Pamet_Bod_3D);
          end;
    end;
end;

procedure Typ_Obdelnik._Zhasni; {vyrusi objekt z jeho mista }
                             {v obrazovce a z jeho z-souradnice}
                             {v poli obraz}
var J, I : Shortint;
    Pom  : Typ_Bod_3D;

begin
  Pom := @Tvar^.Tvar[0];      {adresa zhasinaneho prvku }
  for J := Poloha.Y{&&&+Poloha.Z} to Poloha.Y{&&&+Poloha.Z}+Rozmer.Y do
    for I := Poloha.X{&&&-Poloha.Z} to Poloha.X{&&&-Poloha.Z}+Rozmer.X do
      begin
        Obrazovka.Zhasni_Bod_Xy(I, J, Pom);
        Inc(Word(Pom),Pamet_Bod_3D);
      end;
end;

end.





